/* $Id: engine.h,v 1.2 2004/01/19 22:31:30 jgordon Exp $ */

/* 
 * $Log: engine.h,v $
 * Revision 1.2  2004/01/19 22:31:30  jgordon
 * merge from GATEWAY_PRODUCT_1_BRANCH (MAINLINE_MP_1) to mainline
 *
 * Revision 1.1.2.1  2004/01/06 01:52:30  alan
 * Threaded interpreter engine
 *
 * Revision 1.1.2.1.2.4.2.4  1999/11/21 16:51:15  helmut
 * minor changes
 *
 * Revision 1.1.2.1.2.5  1999/11/21 16:35:56  helmut
 * rename intermediate_<x> to get_icode_<x>
 *
 * Revision 1.1.2.1.2.4.2.3  1999/11/15 23:38:16  helmut
 * use Instr union in place of casts to increase portability.
 *
 * Revision 1.1.2.1.2.4.2.2  1999/11/15 17:20:19  helmut
 * some checks disabled
 *
 * Revision 1.1.2.1.2.4.2.1  1999/11/14 20:09:10  helmut
 * quick instructions for ldc, invoke and putfield.
 *
 * Revision 1.1.2.1.2.4  1999/11/14 15:30:49  helmut
 * removed some costly assertions.
 *
 * Revision 1.1.2.1.2.3  1999/11/14 12:16:01  helmut
 * check in NEXT from next
 *
 * Revision 1.1.2.1.2.2  1999/11/11 18:50:35  helmut
 * *** empty log message ***
 *
 * Revision 1.1.2.1.2.1  1999/11/10 11:49:22  helmut
 * *** empty log message ***
 *
 * Revision 1.1.2.1  1999/10/31 18:21:17  helmut
 * First checkin.
 *
 */

#ifndef __engine_h
#define __engine_h



typedef union instr {
  void*   p;
  float	  f;
  uint32  u;
  int32   i;
} Instr;


typedef enum {
  __CustomInstructionsDummyBeg=255,
# define instr(name,opcode,label,len,syn,body) 
# define undef(name,opcode,label,len,syn,body) 
# define custm(name,opcode,label,len,syn,body) name,
# include "threaded_int.def"
# undef instr
# undef undef
# undef custm
  __CustomInstructionsDummyEnd
} CustomInstructions;


#define N_CUSTOM_INSTRUCTIONS \
(__CustomInstructionsDummyEnd-__CustomInstructionsDummyBeg)


				/* direct threaded  */

#define NEXT(step)	{		\
	__ip += (step);			\
        mjbuf->frame.intrp.pc = __ip-icodep;	\
	goto *(__ip->p);}

#define JMP(new_ip)		{__ip = (new_ip); NEXT(0);}
#define BRA(offset)		{__ip += (offset); NEXT(0);}
#define IP			__ip
#define RESTORE_IP(old_ip)	{__ip=(old_ip); }


#define THIS ((Hjava_lang_Object *)(fp[0].l))
#define TOS (sp[0])
#define STACK(offset) (sp[-(offset)])
#define PUSH_I(value) {push(1); sp[0].v.tint = (value);}
#define PUSH_L(value) {push(1); sp[0].v.taddr = (value);}

#define LOCAL(index) (fp[(index)])


#define SAVE_REGISTERS {rp++; rp->mp = mp; rp->fp = fp; rp->ip = IP;}
#define RESTORE_REGISTERS { \
	Instr stored_ip = rp->ip; \
	fp = rp->fp;		\
	mp = rp->mp; 		\
	rp--;			\
	JMP(stored_ip);}


#define PC (IP-((Instr *)meth->icode))	
#define INTERNAL_IP (__ip)
#define getpc(x) (meth->c.bcode.code[PC+(x)+1])	/* byte code! */

/* offset 0 means the first operand of the current instruction */
#define get_icode_uint8(offset)		(__ip[(offset)+1].u)
#define get_icode_int8(offset)		(__ip[(offset)+1].i)
#define get_icode_uint16(offset)	(__ip[(offset)+1].u)
#define get_icode_int16(offset)		(__ip[(offset)+1].i)
#define get_icode_uint32(offset)	(__ip[(offset)+1].u)
#define get_icode_int32(offset)		(__ip[(offset)+1].i)
#define get_icode_float(offset)		(__ip[(offset)+1].f)
#define get_icode_pointer(offset)	(__ip[(offset)+1].p)

/* offset 0 means the instruction being executed */
#define set_icode_p(offset,value)  {__ip[offset].p=(value);}
#define set_icode_f(offset,value)  {__ip[offset].f=(value);}
#define set_icode_i(offset,value)  {__ip[offset].i=(value);}
#define set_icode_u(offset,value)  {__ip[offset].u=(value);}

Instr* get_labels(void);
Instr  get_translate_label(void);


#endif /* __engine_h */
