//
// de.gyronet.kangaroo.io.JarConnection.c
// kangaroo
//
// Created by Marc Kleine-Budde on 03.31.2003
// Copyright (c) 2003 GYRO net GmbH. All rights reserved.
//
// inspired by / copied from: java.util.zip.ZipFile.c
// from the Kaffe Project
//
// see original Copyright below... 

/*
 * java.util.zip.ZipFile.c
 *
 * Copyright (c) 1996, 1997, 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

#include "config.h"
#include "config-std.h"
#include "config-io.h"
#include "config-mem.h"
#include "files.h"
#include "../../../kaffe/kaffevm/gtypes.h"
#include "../../../kaffe/kaffevm/jar.h"
#include "../../../kaffe/kaffevm/itypes.h"
#include "../../../kaffe/kaffevm/gc.h"
#include "de_gyronet_kangaroo_io_JarConnection.h"
#include <errors.h>


struct Hkaffe_util_Ptr* de_gyronet_kangaroo_io_JarConnection_open0
(struct Hde_gyronet_kangaroo_io_JarConnection* this,
 struct Hjava_lang_String* fname)
{
	jarFile* jar;
	char* str;

	str = checkPtr(stringJava2C(fname));
	jar = openJarFile(str);
	KFREE(str);
	return (struct Hkaffe_util_Ptr*)jar;
}

void de_gyronet_kangaroo_io_JarConnection_getResource0
(struct Hde_gyronet_kangaroo_io_JarConnection* this,
 struct Hkaffe_util_Ptr* jar, struct Hjava_lang_String* zname)
{
	jarEntry* entry;
	char* str;

	str = checkPtr(stringJava2C(zname));
	entry = lookupJarFile((jarFile*)jar, str);
	KFREE(str);

	if (entry == 0) {
		SignalError("java.io.FileNotFoundException", "");
	}

	unhand(this)->size = entry->uncompressedSize;
	unhand(this)->method = entry->compressionMethod;
	unhand(this)->csize = entry->compressedSize;
	unhand(this)->offset = entry->localHeaderOffset;
}

HArrayOfByte* de_gyronet_kangaroo_io_JarConnection_getJarData0
(struct Hde_gyronet_kangaroo_io_JarConnection* this,
 struct Hkaffe_util_Ptr* jar)
{
	jarEntry entry;
	HArrayOfByte* array;
	uint8* buf = 0;

	if (unhand(this)->size > 0) {
		entry.fileName = "";
		entry.uncompressedSize = unhand(this)->size;
		entry.compressionMethod = unhand(this)->method;
		entry.compressedSize = unhand(this)->csize;
		entry.localHeaderOffset = unhand(this)->offset;
		
		buf = getDataJarFile((jarFile*)jar, &entry);
		if (buf == 0) {
			return 0;
		}
	}

	array = (HArrayOfByte*)AllocArray(unhand(this)->size, TYPE_Byte);
	if (buf) {
		memcpy(unhand_array(array)->body, buf, unhand(this)->size);
		gc_free(buf);
	}

	return array;
}

void de_gyronet_kangaroo_io_JarConnection_close0
(struct Hde_gyronet_kangaroo_io_JarConnection* this,
 struct Hkaffe_util_Ptr* jar)
{
	closeJarFile((jarFile*)jar);
}
