#include <jni.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "i802.h"
#include "jsyscall.h"

/* read the contents of a file into a newly created buffer */
char *readFile( char *fileName, int *bytesread, int buffersize ) {

	int fd, err;
	char *buffer;

	buffer = malloc( sizeof(char) * buffersize );

	err = KOPEN(fileName, O_RDONLY, 0, &fd);
	if(err == 0) {
		err = KREAD(fd, buffer, buffersize, bytesread);
		KCLOSE(fd);
	} else {
		free(buffer);
		buffer = NULL;
	}
	return buffer;
}


/* return the contents of the file whose name is passed in as a string.
 * parameters are String filename, int bytesToRead.
 */
JNIEXPORT 
jstring
Java_com_instant802_cldc_linuxfstools_SimpleFileReader_rawGetFile(JNIEnv *env, jobject ob, jstring name,  jint buffersize) {

	char *fileName;
	char *buffer;
	int bytesread;
	jstring bufstr;

	/* copy the name into a c string */
	fileName = (*env)->GetStringUTFChars(env, name, NULL);

	/* read the file into the buffer */
	buffer = readFile( fileName, &bytesread, buffersize );

	if( buffer ) {
		/* copy the contents of the buffer into the java string */
		bufstr = (*env)->NewStringUTF( env, buffer);
		 /* free the buffer */
		free( buffer );    
	} else {
		/* if there's no content return null */
		bufstr = NULL;
	}
	(*env)->ReleaseStringUTFChars(env, name, fileName);
	/* clean up the object references and return the java string */
	return bufstr;
}
