#include <jni.h>
#include "i802.h"
#include <stdio.h>
#include <openssl/des.h>
#include <errno.h>

extern void i802_ssl_init(void);

JNIEXPORT 
jint
	Java_com_instant802_cldc_ssl_DES_init(JNIEnv *env, jobject ob,
	         jbyteArray jkey, jint keylen) {
		// (byte[] key, int keylen) - returns pointer to DES_key_schedule of key
		DES_key_schedule *pkeys;		
		char *pskey;
		
		i802_ssl_init();		
		pskey = (char *) malloc(keylen + 1);
		pkeys = (DES_key_schedule *) malloc(sizeof(DES_key_schedule));

		(*env)->GetByteArrayRegion(env, jkey, 0, keylen, pskey);		
		DES_set_key_checked((const_DES_cblock *)pskey, pkeys);		
		free(pskey);
		return (jint)pkeys;
	}

JNIEXPORT 
void
	Java_com_instant802_cldc_ssl_DES_ecbencrypt(JNIEnv *env, jobject ob, 
	     jint ikeys, jbyteArray jbin, jbyteArray jbout) {
	// (*pkeys, byte[8] in, byte[8] out)
		char bin[8], bout[8];
		DES_key_schedule *pkeys;
		
		pkeys  = (DES_key_schedule *) ikeys;
		(*env)->GetByteArrayRegion(env, jbin, 0, 8, bin);
		DES_ecb_encrypt((const_DES_cblock *) bin, (DES_cblock *) bout, pkeys, 1); // encrypt
		(*env)->SetByteArrayRegion(env, jbout, 0, 8, bout);		
	}
		
JNIEXPORT
void
	Java_com_instant802_cldc_ssl_DES_free(JNIEnv *env, jobject ob, jint ikey) {
	// (*pkey)	
		void * pmem;
		
		pmem = (void *) ikey;
		free(pmem);
	}
