#include <jni.h>
#include "i802.h"

#include <stdio.h>
#include <openssl/sha.h>
#include <errno.h>

extern void i802_ssl_init(void);

JNIEXPORT 
jint
	Java_com_instant802_cldc_ssl_SHA_init(JNIEnv *env, jobject ob) {
		SHA_CTX *pctx;
		pctx = (SHA_CTX *) malloc( sizeof(SHA_CTX));
		i802_ssl_init();		
		SHA_Init(pctx);
		return (jint)pctx;
	}

JNIEXPORT 
void
	Java_com_instant802_cldc_ssl_SHA_update(JNIEnv *env, jobject ob,
			jint ictx, jbyteArray jtext, jint textlen) {
	// (*pctx, byte[] text, int textlen)
		char *text;
		SHA_CTX *pctx;
		
		pctx = (SHA_CTX *) ictx;
		text = malloc(textlen);
		(*env)->GetByteArrayRegion(env, jtext, 0, textlen, text);
		SHA_Update(pctx, text, textlen);	
		free(text);
	}
		
JNIEXPORT
void
	Java_com_instant802_cldc_ssl_SHA_finale(JNIEnv *env, jobject ob,
		 jint ictx, jbyteArray jtext) {
	// (*pctx, byte[20] text)
		char buff[20];
		SHA_CTX *pctx;
		
		pctx = (SHA_CTX *) ictx;
		SHA_Final(buff, pctx);
		(*env)->SetByteArrayRegion(env, jtext, 0, 20, buff);
		free(pctx);
	}
