//
// de.gyronet.kangaroo.io.FileConnection.java
// kangaroo
//
// Created by Marc Kleine-Budde on 03.28.2003
// Copyright (c) 2003 GYRO net GmbH. All rights reserved.
//
// inspired by
// the Kaffe Project
//

package de.gyronet.kangaroo.io;

import java.util.Hashtable;
import java.io.IOException;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import javax.microedition.io.Connection;
import javax.microedition.io.StreamConnection;

public class FileConnection implements Protocol, StreamConnection {
    public static final String separator = System.getProperty("file.separator");
    public static final String pathSeparator = System.getProperty("path.separator");
    
    FileDescriptor con;

    public Connection open(String target, Hashtable params, int mode, boolean timeouts) throws IOException {
	con = new FileDescriptor();

	con.mode = mode;

	/*
	 * open file
	 */
	con.open0(target, mode);

	con.open = true;
	con.openCounter++;

	return this;
    }

    public void close() throws IOException {
	con.close();
    }

    public InputStream openInputStream() throws IOException {
        return con.openInputStream();
    }
    
    public DataInputStream openDataInputStream() throws IOException {
        return con.openDataInputStream();
    }

    public OutputStream openOutputStream() throws IOException {
        return con.openOutputStream();
    }
    
    public DataOutputStream openDataOutputStream() throws IOException {
        return con.openDataOutputStream();
    }
}
