//
// de.gyronet.kangaroo.io.TCPConnection.java
// kangaroo
//
// Created by Marc Kleine-Budde on 04.04.2003
// Copyright (c) 2003 GYRO net GmbH. All rights reserved.
//
// inspired by / copied from: java.net.PlainSocketImpl.java
//			      java.net.Socket.java
// from the Kaffe Project
//
// see original Copyright below... 

/*
 * Java core library component.
 *
 * Copyright (c) 1997, 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

package de.gyronet.kangaroo.io;

import java.io.IOException;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.lang.IllegalArgumentException;
import java.util.Hashtable;
import javax.microedition.io.Connection;
import javax.microedition.io.SocketConnection;

public class TCPConnection implements SocketConnection {

    InetImpl con;

    TCPConnection() {
    }

    TCPConnection(InetImpl con) {
	this.con = con;
    }

    Connection open(URL targetURL, Hashtable params, int mode, boolean timeouts) throws IOException {
	con = new InetImpl();

	con.timeout = timeouts ? 60000 : 0;
	con.mode = mode;

	try {
	    con.create0(true);				       	//true means streamconnection
	    con.connect0(targetURL.addr, targetURL.port);
	} catch (IOException e) {
	    try {
		con.close();
	    } catch (IOException _) {
	    }
	    throw(e);
	}

	con.open = true;
	con.openCounter++;

	return this;
    }


    public int getSocketOption(byte option) throws IllegalArgumentException, IOException {
	return con.getSocketOption(option);
    }

    public void setSocketOption(byte option, int value) throws IllegalArgumentException, IOException {
	con.setSocketOption(option, value);
    }


    public String getAddress() throws IOException {
	return con.getAddress();
    }
    public String getLocalAddress() throws IOException {
	return con.getLocalAddress();
    }

    public int getLocalPort() throws IOException {
	return con.getLocalPort();
    }

    public int getPort() throws IOException {
	return con.getPort();
    }

    public void close() throws IOException {
	con.close();
    }

    public InputStream openInputStream() throws IOException {
        return con.openInputStream();
    }
    
    public DataInputStream openDataInputStream() throws IOException {
        return con.openDataInputStream();
    }

    public OutputStream openOutputStream() throws IOException {
        return con.openOutputStream();
    }
    
    public DataOutputStream openDataOutputStream() throws IOException {
        return con.openDataOutputStream();
    }
}
