//
// de.gyronet.kangaroo.lang.reflect.Array.java
// kangaroo
//
// Created by Marc Kleine-Budde on 02.11.2003
// Copyright (c) 2003 GYRO net GmbH. All rights reserved.
//
// inspired by / copied from: java.lang.reflect.Array.java
// from the Kaffe Project
//
// see original Copyright below... 

/*
 * Java core library component.
 *
 * Copyright (c) 1997, 1998, 2001, 2002
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 *
 */

package de.gyronet.kangaroo.lang.reflect;

/**
 * @version $Id: Array.java,v 1.2 2003/11/02 09:14:16 carter Exp $
 * @author Marc Kleine-Budde
 *
 */

public final class Array {
    public static Object newInstance(Class componentType, int len) throws NegativeArraySizeException {
	checkComponentType(componentType);

	if (len < 0) {
	    throw new NegativeArraySizeException();
	}

	if (!componentType.isPrimitive()) {
	    return (newArray(componentType, len));

	} else if (componentType == Boolean.TYPE) {
	    return (new boolean[len]);

	} else if (componentType == Byte.TYPE) {
	    return (new byte[len]);

	} else if (componentType == Short.TYPE) {
	    return (new short[len]);

	} else if (componentType == Character.TYPE) {
	    return (new char[len]);

	} else if (componentType == Integer.TYPE) {
	    return (new int[len]);

	} else if (componentType == Long.TYPE) {
	    return (new long[len]);

	} else {
	    throw new Error();
	}
    }

    private static void checkComponentType(Class componentType) {
	if (componentType == null) {
	    throw new NullPointerException();
	}
// 	if (componentType == Void.TYPE) {
// 	    throw new IllegalArgumentException();
// 	}
    }

    native private static Object newArray(Class componentType, int len);
}
