
package java.io;



public class OutputStreamWriter extends Writer {
    private Writer out;



    public OutputStreamWriter(OutputStream os) {
        out = new de.gyronet.kangaroo.io.ISO8859_1_Writer().open(os);
    }

    public OutputStreamWriter(OutputStream os, String enc) throws UnsupportedEncodingException {
        if(!enc.equals("ISO8859_1")) throw new UnsupportedEncodingException();
        
        out = new de.gyronet.kangaroo.io.ISO8859_1_Writer().open(os);
    }



    public void close() throws IOException {
        if(out != null) {
            out.close();
            out = null;
        }
    }

    public void flush() throws IOException {
        ensureOpen();
        out.flush();
    }

    public void write(char cbuf[], int off, int len) throws IOException {
        ensureOpen();
        if ((off < 0) || (off > cbuf.length) || (len < 0) ||
            ((off + len) > cbuf.length) || ((off + len) < 0)) {
            throw new IndexOutOfBoundsException();
        } else if (len == 0) {
            return;
        }
        out.write(cbuf, off, len);
    }

    public void write(int c) throws IOException {
        ensureOpen();
        out.write(c);
    }

    public void write(String str, int off, int len) throws IOException {
        ensureOpen();
        if ((off < 0) || (off > str.length()) || (len < 0) ||
            ((off + len) > str.length()) || ((off + len) < 0)) {
            throw new IndexOutOfBoundsException();
        } else if (len == 0) {
            return;
        }
        out.write(str, off, len);
    }



    private void ensureOpen() throws IOException {
        if (out == null) {
            throw new IOException("Stream closed");
        }
    }
}
