#ifndef __OPERATIONS_H__
#define __OPERATIONS_H__

typedef struct dot11_oper_info_s{
	int if_index;
	char mac_address[6];
	int mac_address_len;
	int rts_threshold;
	int short_retry_limit;
	int long_retry_limit;
	int fragmentation_threshold;
	int max_trans_msdu_lifetime;
	int max_recv_lifetime;
	char manufacturer_id[128];
	int manufacturer_id_len;
	char product_id[128];
	int product_id_len;
}dot11_oper_info;


int GetOperationsEntries(void);
int GetOperationsTableData(void);
int GetOperationTableIndexCount(void);
void GetOperationsEntryByIndex(int index, dot11_oper_info *info);
int SetRTSThreshold(dot11_oper_info *info, int *val, int len);
int SetShortRetryLimit(dot11_oper_info *info, int *val, int len);
int SetLongRetryLimit(dot11_oper_info *info, int *val, int len);
int SetFragmentationThreshold(dot11_oper_info *info, int *val, int len);
int SetMaxTransmitMSDULifetime(dot11_oper_info *info, int *val, int len);
int SetMaxReceiveLifetime(dot11_oper_info *info, int *val, int len);
#endif  /* __OPERATIONS_H__*/
