<!-- Copyright 2004 Instant802 Networks, Inc. All Rights Reserved. -->

<?ct def:print_dtim_period(layer_prefix, radio, bss) ?>
    <?ct set:input_name = "r" + radio + "b" + bss + "DtimPeriod" ?>
    <!-- dtim period -->
    <tr>
        <td class=namelevelone>
            DTIM Period
        </td>
        <?ct call:print_vfiller() ?>
        <td class="value">
            <div class=units>
                <input class="value" type=text size=5 
                 <?ct call:print_prefixed_text_name_value(layer_prefix, input_name) ?>> (Range: 1-255)
            </div>
        </td>
    </tr>
<?ct /def ?>

<?ct def:print_fragm_threshold(layer_prefix, radio) ?>
    <?ct set:input_name = "r" + radio + "FragmThreshold" ?>
    <!-- fragmentation length -->
    <tr>
        <td class=namelevelone>
            Fragmentation Threshold
        </td>
        <?ct call:print_vfiller() ?>
        <td class="value">
            <div class=units>
                <input class="value" type=text size=4 <?ct call:print_prefixed_text_name_value(layer_prefix, input_name) ?>> (Range: 256-2346, even numbers only)
            </div>
        </td>
    </tr>
<?ct /def ?>

<?ct def:print_rts_threshold(layer_prefix, radio) ?>
    <?ct set:input_name = "r" + radio + "RtsThreshold" ?>
    <!-- rts threshold -->
    <tr>
        <td class=namelevelone>
            RTS Threshold
        </td>
        <?ct call:print_vfiller() ?>
        <td class="value">
            <div class=units>
                <input class="value" type=text size=4 <?ct call:print_prefixed_text_name_value(layer_prefix, input_name) ?>> (Range: 0-2347)
            </div>
        </td>
    </tr>
<?ct /def ?>

<?ct def:print_max_stations(layer_prefix, radio, bss) ?>
    <?ct set:input_name = "r" + radio + "b" + bss + "MaxStations" ?>
    <!-- maximum stations -->
    <tr>
        <td class=namelevelone>
            Maximum Stations
        </td>
        <?ct call:print_vfiller() ?>
        <td class="value">
            <div class=units>
                <input class="value" type=text size=4 <?ct call:print_prefixed_text_name_value(layer_prefix, input_name) ?>> (Range: 0-<?ct var:Site.LimitNumStations ?>)
            </div>
        </td>
    </tr>
<?ct /def ?>

<?ct def:print_tx_power_adjustment(layer_prefix, radio) ?>
    <?ct set:input_name = "r" + radio + "TxPowerAdjustment" ?>
    <!-- transmit power -->
    <tr>
        <td class=namelevelone>
            Transmit Power
        </td>
        <?ct call:print_vfiller() ?>
        <td class="value">
            <div class=units>
                <input class="value" type=text size=4 <?ct call:print_prefixed_text_name_value(layer_prefix, input_name) ?>> (Percent)
            </div>
        </td>
    </tr>
<?ct /def ?>

<?ct def:print_beacon_interval(layer_prefix, radio, min, max) ?>
    <?ct set:input_name = "r" + radio + "BeaconInterval" ?>
    <!-- beacon interval -->
    <tr>
        <td class=namelevelone>
            Beacon Interval
        </td>
        <?ct call:print_vfiller() ?>
        <td class="value">
            <div class=units>
                <input class="value" type=text size=4 <?ct call:print_prefixed_text_name_value(layer_prefix, input_name) ?>> (Msec, Range: <?ct var:min ?> - <?ct var:max ?>)
            </div>
        </td>
    </tr>
<?ct /def ?>

<?ct def:print_super_ag(layer_prefix, radio) ?>
    <!-- super ag -->
    <tr>
        <td class=namelevelone>
            Super G
        </td>
        <?ct call:print_vfiller() ?>
        <td class=value>
	    <?ct set:input_name = "r" + radio + "SuperAG" ?>
            <input class=value type=radio value="yes"
                <?ct call:print_prefixed_box_name_checked(layer_prefix, input_name, "yes") ?>> Enabled
            <input class=value type=radio value="no"
                <?ct call:print_prefixed_box_name_checked(layer_prefix, input_name, "no") ?>> Disabled
        </td>
    </tr>
<?ct /def ?>

<?ct def:print_11a_layer_common(layer_prefix, radio, turbo) ?>
    <!-- settings common to 11a and 11a turbo -->
    <?ct if: ! CONFIG_OAP_GUEST ?>
        <?ct call:print_radio_ssid(layer_prefix, radio, 1, 1) ?>
        <?ct call:print_hfiller(#0) ?>
    <?ct /if ?>
    <?ct if: CONFIG_OAP_RADIO_SUPER_AG ?>
    	<?ct call:print_super_ag(layer_prefix, radio) ?>
    	<?ct call:print_hfiller(#0) ?>
    <?ct /if ?>
    <?ct call:print_channel(layer_prefix, radio) ?>
    <?ct call:print_hfiller(#0) ?>
    <?ct call:print_beacon_interval(layer_prefix, radio, #20, #2000) ?>
    <?ct call:print_hfiller(#0) ?>
    <!-- XXX Have separate items for BSSes? -->
    <?ct call:print_dtim_period(layer_prefix, radio, 1) ?>
    <?ct call:print_hfiller(#0) ?>
    <?ct call:print_fragm_threshold(layer_prefix, radio) ?>
    <?ct call:print_hfiller(#0) ?>
    <?ct call:print_rts_threshold(layer_prefix, radio) ?>
    <?ct call:print_hfiller(#0) ?>
    <!-- XXX Have separate items for BSSes? -->
    <?ct call:print_max_stations(layer_prefix, radio, 1) ?>
    <?ct call:print_hfiller(#0) ?>
    <?ct call:print_tx_power_adjustment(layer_prefix, radio) ?>

    <?ct call:print_hfiller(#0) ?>
<?ct /def ?>

<?ct def:print_transmission_rate_checkbox(layer_prefix, name, item) ?>
    <input type=checkbox value=<?ct var:item.Value ?> onClick="resetRates(this)"
    <?ct call:print_prefixed_box_name_checked(layer_prefix, name, item.Value) ?>>
<?ct /def ?>

<?ct def:print_transmission_rates(layer_prefix, radio, list) ?>
    <tr>
        <td class=namelevelone>
            Rate Sets
            <input type=hidden name="<?ct var:layer_prefix ?>r<?ct var:radio ?>SupportedRate" value="hidden">
            <input type=hidden name="<?ct var:layer_prefix ?>r<?ct var:radio ?>BasicRate" value="hidden">
        </td>
        <?ct call:print_vfiller() ?>
        <td class="value">
              <table class="units">
                <tr>
                  <td align="right">
                    <u>Rate</u>
                  </td>
                  <td align="center">
                    <u>Supported</u>
                  </td>
                  <td align="center">
                    <u>Basic</u>
                  </td>
                </tr>
                <?ct each:driveritem = list ?>
                  <tr>
                    <td align="right">
                      <?ct var:driveritem.Name ?> Mbps
                    </td>
                    <td align="center">
                      <?ct call:print_transmission_rate_checkbox(layer_prefix, "r" + radio + "SupportedRate", driveritem) ?>
                    </td>
                    <td align="center">
                      <?ct call:print_transmission_rate_checkbox(layer_prefix, "r" + radio + "BasicRate", driveritem) ?>
                    </td>
                  </tr>
                <?ct /each ?>
              </table>
        </td>
    </tr>
<?ct /def ?>

<?ct def:print_11a_layer(layer_prefix, radio) ?>
    <!-- 11a settings -->
    <div class="radio-layer" id="r<?ct var:radio ?>alayer">
    <?ct if:CONFIG_OAP_DEBUG ?>
        ___________________<?ct var:layer_prefix ?>r<?ct var:radio ?>
    <?ct /if ?>
        <table align="center">
        <?ct call:print_11a_layer_common(layer_prefix, radio, "") ?>
        <?ct call:print_transmission_rates(layer_prefix, radio, Driver.0.Rate) ?>
        </table>
    </div>
<?ct /def ?>

<?ct def:print_11a_turbo_layer(layer_prefix, radio) ?>
    <!-- 11a turbo settings -->
    <div class="radio-layer" id="r<?ct var:radio ?>a_turbo_layer">
    <?ct if:CONFIG_OAP_DEBUG ?>
        ______________________________________<?ct var:layer_prefix ?>r<?ct var:radio ?>
    <?ct /if ?>
        <table align="center">
        <?ct call:print_11a_layer_common(layer_prefix, radio, "Turbo") ?>
        <?ct call:print_transmission_rates(layer_prefix, radio, Driver.1.Rate) ?>
        </table>
    </div>
<?ct /def ?>

<?ct def:print_11bg_layer(layer_prefix, radio) ?>
    <!-- settings common to 11b and 11g -->
    <?ct if: ! CONFIG_OAP_GUEST ?>
        <?ct call:print_radio_ssid(layer_prefix, radio, 1, 1) ?>
        <?ct call:print_hfiller(#0) ?>
    <?ct /if ?>
    <?ct if: CONFIG_OAP_RADIO_SUPER_AG ?>
    	<?ct call:print_super_ag(layer_prefix, radio) ?>
	    <?ct call:print_hfiller(#0) ?>
    <?ct /if ?>
    <?ct call:print_channel(layer_prefix, radio) ?>
    <?ct call:print_hfiller(#0) ?>
    <?ct call:print_beacon_interval(layer_prefix, radio, #20, #2000) ?>
    <?ct call:print_hfiller(#0) ?>
    <!-- XXX Have separate items for BSSes? -->
    <?ct call:print_dtim_period(layer_prefix, radio, 1) ?>
    <?ct call:print_hfiller(#0) ?>
    <?ct call:print_fragm_threshold(layer_prefix, radio) ?>
    <?ct call:print_hfiller(#0) ?>
    <?ct call:print_rts_threshold(layer_prefix, radio) ?>
    <?ct call:print_hfiller(#0) ?>
    <!-- XXX Have separate items for BSSes? -->
    <?ct call:print_max_stations(layer_prefix, radio, 1) ?>
    <?ct call:print_hfiller(#0) ?>
    <?ct call:print_tx_power_adjustment(layer_prefix, radio) ?>

    <?ct call:print_hfiller(#0) ?>
<?ct /def ?>

<?ct def:print_11b_layer(layer_prefix, radio) ?>
    <!-- 11b settings -->
    <div class="radio-layer" id="r<?ct var:radio ?>blayer">
    <?ct if:CONFIG_OAP_DEBUG ?>
        _________________________________________________________<?ct var:layer_prefix ?>r<?ct var:radio ?>
    <?ct /if ?>
    <table align="center">
        <?ct call:print_11bg_layer(layer_prefix, radio) ?>
        <?ct call:print_transmission_rates(layer_prefix, radio, Driver.0.Rate) ?>
    </table>
    </div>
<?ct /def ?>

<?ct def:print_11g_layer(layer_prefix, radio) ?>
    <!-- 11g settings -->
    <div class="radio-layer" id="r<?ct var:radio ?>glayer">
    <?ct if:CONFIG_OAP_DEBUG ?>
        <?ct var:layer_prefix ?>r<?ct var:radio ?>
    <?ct /if ?>
    <table align="center">
        <?ct call:print_11bg_layer(layer_prefix, radio) ?>
        <?ct call:print_transmission_rates(layer_prefix, radio, Driver.1.Rate) ?>
    </table>
    </div>
<?ct /def ?>

<?ct def:print_11a_dyn_turbo_layer(layer_prefix, radio) ?>
    <!-- 11a dyn turbo settings -->
    <div class="radio-layer" id="r<?ct var:radio ?>a_dyn_turbo_layer">
    <table align="center">
        <?ct call:print_11a_layer_common(layer_prefix, radio, "Turbo") ?>
        <?ct call:print_transmission_rates(layer_prefix, radio, Driver.4.Rate) ?>
    </table>
    </div>
<?ct /def ?>

<?ct def:print_11g_turbo_layer(layer_prefix, radio) ?>
    <!-- 11g turbo settings -->
    <div class="radio-layer" id="r<?ct var:radio ?>g_turbo_layer">
    <table align="center">
        <?ct call:print_11bg_layer(layer_prefix, radio) ?>
        <?ct call:print_transmission_rates(layer_prefix, radio, Driver.5.Rate) ?>
    </table>
    </div>
<?ct /def ?>

<?ct def:print_11g_dyn_turbo_layer(layer_prefix, radio) ?>
    <!-- 11g dyn turbo settings -->
    <div class="radio-layer" id="r<?ct var:radio ?>g_dyn_turbo_layer">
    <table align="center">
        <?ct call:print_11bg_layer(layer_prefix, radio) ?>
        <?ct call:print_transmission_rates(layer_prefix, radio, Driver.6.Rate) ?>
    </table>
    </div>
<?ct /def ?>

<?ct def:print_set_rates_to_default() ?>
            function setRatesToDefault(mode, radio) {
                var e;
                switch (mode) {<?ct each:driver = Driver ?>
                case "<?ct var:driver.FullName ?>":<?ct each:rate = driver.Rate ?>
                    e = findElementByNameAndValue("<?ct var:driver.FullName ?>r" + radio + "SupportedRate","<?ct var:rate.Value ?>");
                    e.checked = true;
                    e = findElementByNameAndValue("<?ct var:driver.FullName ?>r" + radio + "BasicRate","<?ct var:rate.Value ?>");
                    <?ct if:rate.DefaultBasic ?>e.checked = true;<?ct else ?>e.checked = false;<?ct /if ?><?ct /each ?>
                    break;<?ct /each ?>
                }
            }
<?ct /def ?>

<?ct def:print_validate_rates() ?>
            function validateRates(mode, radio) {
                var e;
                switch (mode) {<?ct each:driver = Driver ?>
                case "<?ct var:driver.FullName ?>":<?ct each:rate = driver.Rate ?>
                    e = findElementByNameAndValue("r" + radio + "BasicRate","<?ct var:rate.Value ?>");
                    if (e.checked == true) {
                        return "";
                    }
                    <?ct /each ?>
                    return "The Rate Sets are invalid: At least one Supported and Basic Rate must be selected.";
                    break;<?ct /each ?>
                }
            }
<?ct /def ?>

<?ct def:print_validate_radio(radio) ?>
            function validateRadio<?ct var:radio ?>() {
            var msg = "";
			var elm;
		if (elm = getElementByName('r<?ct var:radio ?>BeaconInterval'))
                    msg = msg + validateBeaconInterval(elm.value);
		if (elm = getElementByName('r<?ct var:radio ?>b1DtimPeriod'))
        	    msg = msg + validateDtimPeriod(elm.value);
		if (elm = getElementByName('r<?ct var:radio ?>FragmThreshold'))
        	    msg = msg + validateFragmThreshold(elm.value);
		if (elm = getElementByName('r<?ct var:radio ?>RtsThreshold'))
 	            msg = msg + validateRtsThreshold(elm.value);
		if (elm = getElementByName('r<?ct var:radio ?>b1MaxStations'))
   	            msg = msg + validateMaxStations(elm.value);
		if (elm = getElementByName('r<?ct var:radio ?>TxPowerAdjustment'))
  	            msg = msg + validateTxPowerAdjustment(elm.value);
		if (elm = getElementByName('r<?ct var:radio ?>Mode'))
	            msg = msg + validateRates(elm.value, <?ct var:radio ?>);

                <?ct if:CONFIG_OAP_RADIOS_2 ?>
                if (msg.length > 0) {
                    msg = 'The Radio <?ct if:radio==1 ?>One<?ct else ?>Two<?ct /if ?> configuration has the following problems:\n' + msg;
                }
                <?ct /if ?>

                return msg;
            }
<?ct /def ?>

<?ct def:print_radio_mode(radio) ?>
    <tr align="center">
	<td align="center">
	    <table align="center">
		<tr>
		    <td class="namelevelone">Mode</td>
		    <?ct call:print_vfiller() ?>
		    <td class="value">
			<select name="r<?ct var:radio ?>Mode" onChange="onModeChange(this,document.forms[0].elements['radioInterface'])">
			    <?ct each:item = Driver ?>
				<?ct lvar: "<" + "?ct if:" + "CONFIG_OAP_RADIO_" + radio + "_MODE_" + item.ConfigName + "?" + ">" + "<option value='" + item.FullName + "' <" + "?i802 selected(" + "r" + radio + "Mode" + ", " + item.FullName + ") ?" + ">>" + item.FullName + "</option><" + "?ct /if ?" + ">" ?>
			    <?ct /each ?>
			</select>
		    </td>
		</tr>
	    </table>
	</td>
    </tr>
<?ct /def ?>

<?ct def:print_radio_status(radio) ?>
    <tr align="center">
		<td align="center">
		    <table align="center">
				<tr>
					<td class="namelevelone"> 
						Status
					</td>
					<?ct call:print_vfiller() ?>
					<td class="value">
						<input class="value" type=radio value="on"
							   onClick="toggleRadioEnabled(true, <?ct var:radio ?>)"
							   <?ct call:print_box_name_checked("r" + radio + "RadioStatus", "on") ?>> On
						<input class="value" type=radio value="off"
							   onClick="toggleRadioEnabled(false, <?ct var:radio ?>)"
							   <?ct call:print_box_name_checked("r" + radio + "RadioStatus", "off") ?>> Off
					</td>
				</tr>
			</table>
		</td>
    </tr>
<?ct /def ?>

<?ct def:print_radio_status_and_mode(radio) ?>
    <div align="center" id="r<?ct var:radio ?>layer">
        <table align="center" width="100%">
            <?ct call:print_radio_status(radio) ?>
            <?ct call:print_hfiller(#0) ?>
            <?ct call:print_radio_mode(radio) ?>
            <?ct call:print_hfiller(#0) ?>
        </table>
    </div>
<?ct /def ?>

<?ct def:print_radio_layers(radio) ?>
    <?ct call:print_11g_layer("IEEE 802.11g", radio) ?>
    <?ct call:print_11b_layer("IEEE 802.11b", radio) ?>
<?ct /def ?>
