/**
 * apc_web_cgi.h - Declarations for the web CGI.
 * Copyright: Copyright 2004 Instant802 Networks, Inc. All Rights Reserved.
 */

#ifndef APC_WEB_CGI_DOT_H
#define APC_WEB_CGI_DOT_H

#include "apc_web_types.h"
#include "../../apc_pool.h"

/**
 * Global pool for allocations for this request.
 * FIXME - it isn't obvious we want to do it this way.
 */
struct apc_pool *apc_web_pool;

/**
 * Initialized the web interface.
 * Args: none
 * Returns: an apc_web_interface_t.
 * Side-effects: None.
 */
apc_web_interface_t *apc_web_init(void);

/**
 * Handles a cgi request for the web interface.
 * Args: none
 * Returns: none
 * Side-effects: Spews to the cgi output fd. Usually stdout.
 */
void apc_web_cgi_handler(apc_web_interface_t *web_interface);

/**
 * Hook for SDK uesrs to add their own handlers.
 */
void apc_web_customize_handlers(apc_web_interface_t *interface);
#endif
