#ifdef MAKE_CLEANUP /* pinch */
ifeq ($(OAP_TOPDIR)/.config,$(wildcard $(OAP_TOPDIR)/.config))
include $(OAP_TOPDIR)/.config
CC=$(CONFIG_OAP_CROSS_COMPILE)gcc
LD=$(CONFIG_OAP_CROSS_COMPILE)ld
CFLAGS+=$(shell echo $(CONFIG_OAP_IEEE80211_EXTRA_CFLAGS))
ifeq ($(CONFIG_CPU_BIG_ENDIAN),y)
LDFLAGS+=-EB
endif
endif
#endif /* MAKE_CLEANUP */ /* pinch */

ifeq ($(LINUX_SOURCE),)
LINUX_SOURCE=/usr/src/linux
endif

ifndef KFLAGS
ifeq ($(CONFIG_AR531X),y)
KFLAGS =	-fno-strict-aliasing -fno-common -G 0 -mno-abicalls \
		-fno-pic -mips32 -Wa,--trap -mlong-calls
else
KFLAGS=-fno-strict-aliasing
endif
endif

CFLAGS+=-D__KERNEL__ -DMODULE -Wall -c -Werror $(KFLAGS)
# CFLAGS += -DI802_PROFILE
# CFLAGS += -g

INCLUDES+=-I$(LINUX_SOURCE)/include

include $(LINUX_SOURCE)/.config

ifdef CONFIG_SPACE_OPTIMISE
CFLAGS+=-Os
else
CFLAGS+=-O2
endif

ifdef CONFIG_X86
ifdef CONFIG_VISWS
MACHINE        := mach-visws
else
MACHINE        := mach-generic
endif
INCLUDES += -I$(LINUX_SOURCE)/arch/i386/$(MACHINE)
endif

ifdef CONFIG_ALPHA
CFLAGS += -mno-fp-regs -ffixed-8
endif

ifdef CONFIG_MODVERSIONS
CFLAGS += -DMODVERSIONS -include $(LINUX_SOURCE)/include/linux/modversions.h
endif

ifdef CONFIG_SMP
CFLAGS += -D__SMP__ -DSMP
endif

ifndef CONFIG_FRAME_POINTER
CFLAGS += -fomit-frame-pointer
endif



OBJS=$(SRCS:%.c=%.o)

%.a: $(OBJS)
	$(AR) rcs $@ $(OBJS)

default-clean:
	$(RM) *.o *.a
	rm -rf .deps

%.o : %.c
	$(CC) $(INCLUDES) -c -o $@ $(CFLAGS) $< 

%.cpp : %.c
	$(CC) $(INCLUDES) -E -c -o $@ $(CFLAGS) $< 

