/*
 * Created on Sep 29, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.instant802.cldc.DataPath;

import java.io.Reader;
import java.util.Hashtable;

import org.kxml2.kdom.Element;
import org.kxml2.kdom.Node;

import com.instant802.cldc.qdxml.DomHandler;
import com.instant802.cldc.qdxml.QDParser;

import com.instant802.cldc.deviceconfiguration.ConfigObject;
import com.instant802.cldc.deviceconfiguration.IndexedConfiguration;
import com.instant802.cldc.deviceconfiguration.Schema;
import com.instant802.cldc.util.Log;

/**
 * @author robin
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public abstract class XMLBase {

	protected static Hashtable entityMap = new Hashtable();

	static {
//		entityMap.put( new Character('\''), "&apos;" );
		entityMap.put( new Character('"' ), "&quot;" );
		entityMap.put( new Character('&' ), "&amp;" );
		entityMap.put( new Character('>' ), "&gt;" );
		entityMap.put( new Character('<' ), "&lt;" );
	}

	protected static String getEncoding() 
	{
		//return System.getProperty("microedition.encoding" );
		return "ISO8859_1";
	}

	public static Element getRootElement(byte[] input) throws XMLRepresentationException {
		DomHandler dom = new DomHandler();
		try { new QDParser().parse(dom, input); }
			catch (Exception e) { Log.error("QDPArser error: " + e.toString()); }
		return dom.getRoot().getRootElement();
	}

	protected IndexedConfiguration getObjects(Schema schema, Element root) throws XMLRepresentationException {
		IndexedConfiguration objects = new IndexedConfiguration();		
		for( int i = 0; i < root.getChildCount(); i ++ ) {
			if( root.getType( i ) == Node.ELEMENT ) {
				Element element = root.getElement( i );
				ConfigObject object = new ConfigObject( schema, element );
				objects.addObject( object );
			}
		}
		return objects;
	}

	protected void closeTag(StringBuffer buffer, String key) {
		buffer.append( "</" ).append( key ).append( ">" );
	}

	protected void openNameTag(StringBuffer buffer, String key, String name) {
		buffer.append("<").append( key ).append(" name=\"").append( name ).append("\">");
	}

	protected void openTag(StringBuffer buffer, String key) {
		buffer.append( "<" ).append( key ).append( ">" );
	}

	protected void appendDocumentStart(StringBuffer buffer) {
		buffer.append("<?xml version=\"1.0\" ?>");
	}

	protected void enTag(StringBuffer sb, String name, String value)
	{
		openTag(sb, name);
		sb.append(value);
		closeTag(sb, name);
	}

	/**
		 * append text to an xml document in a stringbuffer, making
		 * appropriate substitutions for required character entities.
		 */
	protected void appendData(StringBuffer document, String data) {
		for( int i = 0; i < data.length(); i++ ) {
			document.append( entityTransform( data.charAt( i ) ) );			
		}
	}

	protected final String entityTransform(char c) {
		Character toMatch = new Character( c );
		String found = (String) entityMap.get( toMatch );
		if( null != found  ) {
			return found; 
		} else {
			return toMatch.toString();
		}
	}
}
