/*
 * Created on Aug 24, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.instant802.cldc.DataPath;

import java.util.Vector;

import org.kxml2.kdom.Document;
import org.kxml2.kdom.Element;
import org.kxml2.kdom.Node;

import com.instant802.cldc.deviceconfiguration.ElementNotFoundException;
import com.instant802.cldc.util.Log;

/**
 * @author robin
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public abstract class XMLRepresentation extends XMLOutputBase {

	public abstract String typeName();

	protected void debug( String message ) {
		if (Log.DEBUG) Log.debug( typeName(), message );
	}

	/**
	 * assuming that the byte array passed in contains a document whose contents
	 * are a series of records, return a vector containing those records.
	 * @param input the byte array containing document containing the records
	 * @return the vector of records parsed
	 * @throws XMLRepresentationException
	 */
	protected Vector parseRecords(byte[] input) throws  XMLRepresentationException {
		Element root = getRootElement(input);
		/* confirm that the document contains an invocation result */
		if( ! root.getName().equals( typeName() ) ) {
			throw new XMLRepresentationException( "XML document is of type: "+root.getName()+" - expected: "+typeName() );
		}
		
		/* create the records */
		Vector parsedRecords = new Vector();
		int recordCount = root.getChildCount();
		if( recordCount > 0 ) {
			parsedRecords = new Vector(); 
			for( int i = 0; i < recordCount; i ++ ) {
				if( root.getType(i) == Document.ELEMENT ) {
					parsedRecords.addElement( new XMLRecord( root.getElement( i ) ) );
				}
			}
		}
		return parsedRecords;
	}

	protected Element findObject(Element root, String type) throws ElementNotFoundException {
		for( int i = 0; i < root.getChildCount(); i++ ) {
			if( root.getType( i ) == Node.ELEMENT ) {
				Element child = root.getElement( i );
				if( child.getName().equals( type ) ) {
					return child;
				}
			}
		}
		throw new ElementNotFoundException("Couldn't find an object of type "+type+" in config " );
	}
}
