/*
 * Created on Oct 4, 2003
 * written by robin
 * (C) 2003 Instant802 Networks Inc
 */
package com.instant802.cldc.LSQL;

import java.util.Enumeration;

import com.instant802.cldc.deviceconfiguration.FieldChanges2;
import com.instant802.cldc.util.Log;

/**
 * @author robin
 */
public class LSQLUpdate extends LSQLObjectQuery {

	private final FieldChanges2 changes;

	LSQLUpdate(FieldChanges2 changes) {
		super( changes.object() );
		this.changes = changes;
	}

	private void debug( String message ) {
		Log.debug( "LSQLUpdate", message );
	}

	protected void appendFields(StringBuffer document) {
		Enumeration fieldNames = changes.fieldNames();
		
		while( fieldNames.hasMoreElements() ) {
			String fieldName = (String) fieldNames.nextElement();
			if( object.writeField( fieldName ) ) {
				appendField(document, fieldName);
			}
		}
	}

	private void appendField(StringBuffer document, String fieldName) {
		openTag( document, fieldName );
		appendData( document, changes.field( fieldName ) );
		closeTag( document, fieldName );
	}

	public void appendQuery(StringBuffer document) {
		openOriginTag( document, UPDATE );
		openType( document );
		appendFields(document);
		closeType( document );
		closeTag( document, UPDATE );
		appendPrimaryKey(document);
		if (Log.DEBUG) debug("produced query " + document );
	}
}
