/*
 * Created on Aug 13, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.instant802.cldc.SessionMonitor;

import java.util.Enumeration;

import com.instant802.cldc.Activation.Activator;
import com.instant802.cldc.Activation.ActivatorException;
import com.instant802.cldc.Activation.InvocationMessage;
import com.instant802.cldc.Activation.InvocationResult;
import com.instant802.cldc.Activation.Service;
import com.instant802.cldc.Activation.ServiceInstanceManager;
import com.instant802.cldc.DataPath.GenericRecord;
import com.instant802.cldc.orchestrator.OrchestratorNode;
import com.instant802.cldc.util.Log;

/**
 * @author robin
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class GlobalSessionMonitor extends Service {

	public static final String TYPE = "GlobalSessionMonitor";
	public static final String METHOD_GET_SESSION_STATUS_TABLE = "getSessionStatusTable";
	private LocalSessionMonitorFactory monitorFactory;
	
	GlobalSessionMonitor( OrchestratorNode node ) throws ActivatorException {
		monitorFactory = new LocalSessionMonitorFactory( node );
	}

	public SessionStatusTable getSessionStatusTable( ) {
		SessionStatusTable table = new SessionStatusTable();
		if (Log.DEBUG) debug("getting list of monitors");
		Enumeration monitors = monitorFactory.getMonitors();
	 	
	 	/* go through each monitor in turn
	 	 * and add the elements retrieved from each to the table.
	 	 */
	 	while( monitors.hasMoreElements() ) {
	 		LocalSessionMonitor monitor = (LocalSessionMonitor) monitors.nextElement();
	 		if (Log.DEBUG) debug("adding records from monitor " + monitor );
			table.addRecords( monitor );
	 	}
	 	if (Log.DEBUG) debug("returning table");
	 	return table;
	}

	private void debug( String message ) {
		Log.debug( TYPE, message );
	}

	/* (non-Javadoc)
	 * @see com.instant802.cldc.Activation.Service#doMethod(java.lang.String, com.instant802.cldc.Activation.InvocationMessage, com.instant802.cldc.Activation.InvocationResult)
	 */
	protected boolean doMethod(String name, InvocationMessage message, InvocationResult result) throws Exception {
		if( name.equals( METHOD_GET_SESSION_STATUS_TABLE )) {
			SessionStatusTable table = getSessionStatusTable();
			Enumeration e = table.records();
			while( e.hasMoreElements() ) {
				result.add( (GenericRecord) e.nextElement() );
			}
			return true;
		}
		return false;
	}
	
	static class InstanceManager extends ServiceInstanceManager {

		/* (non-Javadoc)
		 * @see com.instant802.cldc.Activation.ServiceInstanceManager#typeName()
		 */
		protected String typeName() {
			return TYPE;
		}

		/* (non-Javadoc)
		 * @see com.instant802.cldc.Activation.ServiceInstanceManager#getInstance(com.instant802.cldc.Activation.Activator)
		 */
		public Service getInstance(String name, OrchestratorNode node, Activator a) throws ActivatorException {
			return new GlobalSessionMonitor( node );
		}
	}
}