/*
 * Created on Apr 13, 2004
 * author: Robin Barooah
 * Copyright (C) 2004 Instant802 Networks, Inc. All Rights Reserved.
 */
package com.instant802.cldc.SystemTests;

import com.instant802.cldc.TestFramework.SystemTest;
import com.instant802.cldc.net.UDPDatagramSocket;
import com.instant802.cldc.net.SocketException;
import com.instant802.cldc.orchestrator.AdminInterface;

/**
 * @author robin
 */
public class ContinuousBroadcastTest extends SystemTest {
	
	private static final int PORT = 5100;
	
	protected void test() {
		testContinuousBroadcast();
	}
	
	private void testContinuousBroadcast() {
		info("getting interface");
		AdminInterface iface = new AdminInterface( "br0" );
		
		String message = "Hello broadcast world!";
		byte[] b = message.getBytes();
		try {
			for( int i = 0; i < 1000; i++ ) { 
				info("broadcast #" + i );
				iface.broadcast( b, PORT );
				info("broadcast done - sleeping for 2 seconds");
				Thread.sleep( 2000 );
			}	
		} catch (SocketException e) {
			info( e );
		} catch (InterruptedException e) {
			info( e );
		}
	}
	
	public static void main( String[] args ) {
		new ContinuousBroadcastTest().run();
	}
}
