/*
 * Created on Jun 22, 2004
 * 
 * To change the template for this generated file go to Window - Preferences -
 * Java - Code Generation - Code and Comments
 */
package com.instant802.cldc.channelplanner;

import java.util.Enumeration;
import java.util.Hashtable;

import com.instant802.cldc.Activation.Activator;
import com.instant802.cldc.clustermembership.ClusterMember;
import com.instant802.cldc.clustermembership.InvocationFailureException;
import com.instant802.cldc.clustermembership.ManualClusterMember;
import com.instant802.cldc.orchestrator.OrchestratorNode;
import com.instant802.cldc.util.Log;

/**
 * @author alan
 * 
 * To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Generation - Code and Comments
 */
public class ChannelPlanExecutor
{

	Activator activator;
	public final static String WLAN_NAME = "wlan_name";
	public final static String CHANNEL_NUMBER = "channel_number";
	private int wlan_threshold, energy_threshold;
	public final static int
		NOT_RUNNING= -1,
		PREPLAN = 0,
		SUCCESS = 1,
		FAIL_EFFICIENCY = 2,
		FAIL_LOAD = 3,
		FAIL_ALL_APS_LOCKED= 4,
		FAIL_OTHER = 5;
	
	public ChannelPlanExecutor(
		int energy_threshold,
		int wlan_threshold,
		OrchestratorNode node)
	{
		this.activator = node.activator();
		this.energy_threshold = energy_threshold;
		this.wlan_threshold = wlan_threshold;
	}

	public int execute(ChannelOptimizationPlan plan)
	{
		Enumeration plans;
		int result;

		if (SUCCESS == (result = meetsConstraints(plan)))
		{
			plans = plan.getPlans().elements();
			while (plans.hasMoreElements())
				execute((Plan) plans.nextElement());
		}
		return result;
	}

	public void forcedExecute(ChannelOptimizationPlan plan)
	{
		Enumeration plans;

		plans = plan.getPlans().elements();
		while (plans.hasMoreElements())
			execute((Plan) plans.nextElement());
	}

	private void execute(Plan plan)
	{
		ClusterMember host = new ManualClusterMember(plan.getIp());
		Hashtable args = new Hashtable();
		args.put(WLAN_NAME, plan.getWlanName());
		args.put(CHANNEL_NUMBER, "" + plan.getNewchannel());
		try
		{
			host.InvokeMethod(
				LocalWirelessNeighborhoodMonitor.TYPE,
				"setWANChannel",
				args);
		} catch (InvocationFailureException e)
		{
			Log.debug(
				"ChannelPlanExecutor: invocation failed: " + e.toString());
		}
	}

	private int meetsConstraints(ChannelOptimizationPlan cop)
	{
		Enumeration plans;
		Plan plan;

		if (cop.postenergy < cop.preenergy * energy_threshold / 100)
		{
			// 	For now ignore APload constraint. Subject to a lot of debate it
			// is not clear  that this measurement makes sense, or, if it does, should be a
			// factor in deciding whether or not to execute the plan
			//
			//			plans = cop.getPlans().elements();
			//			while (plans.hasMoreElements())
			//			{
			//				plan = (Plan) plans.nextElement();
			//				if (plan.getChannelload() > wlan_threshold)
			//					return FAIL_LOAD;
			//			}
			return SUCCESS;
		}
		return FAIL_EFFICIENCY;
	}
}
