/*
 * Created on Jun 21, 2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package com.instant802.cldc.channelplanner;

/**
 * @author alan
 *
 * For now simply keep a rolling average of the current and last measurements
 * Eventually keep a rolling window
 */
public class NeighborAPRecord
{
	private static final int NULL_VALUE = -57575757;
	private long ts, channel_change_ts;
	private int channel = NULL_VALUE, host_channel;
	private int signal = NULL_VALUE;
	private long host_load = NULL_VALUE;
	private static final long FRESH_TIME = 3600 * 1000L * 3;  // If AP hasn't been seen in 3 hours
	private String host_mac, radio_mac, host_ip;
	private int beacon_interval;
	private long last_beacon_ts;
	private int rate;
	private String ssid, location, host_band, host_ssid;
	
	public NeighborAPRecord() {
		touch();	
	}
	
	public void update(WirelessNeighborhoodRecord record)
	{
		int cursignal = record.signal();
		int curchannel =record.channel();
		long curload =record.getHostRadioLoad();
		
		if (NULL_VALUE == signal) {
			signal = cursignal;
		} else
			signal = (signal + cursignal) / 2;
		
		if (NULL_VALUE == channel || channel != curchannel) {
			channel_change_ts = System.currentTimeMillis();
			channel = curchannel;
		}
		
		if (NULL_VALUE == host_load) {
			host_load = curload;
		} else
			host_load = (curload + host_load) / 2;
		
		host_channel = record.getHostRadioChannel();
		host_mac = record.getHostRadioMac();
		host_band = record.getHostRadioBand();	
		host_ssid = record.getHostSSID();
		ssid = record.ssid();
		radio_mac = record.macAddress();
		host_ip = record.getHostIP();
		beacon_interval = record.beaconInterval();
		last_beacon_ts = record.lastBeaconTS();
		rate = record.rate();
		location = record.location();
		touch();
	}
	
	public int getSignal() {
		return signal;
	}
	
	public int getChannel() {
		return channel;
	}
	
	public long getHostLoad() {
		return host_load;
	}
	
	public String getHostMac() {
		return host_mac;
	}
	
	public String getHostBand() {
		return host_band;
	}
	
	public String getHostIP() {
		return host_ip;
	}
	
	public String getNbrMac() {
		return radio_mac;
	}

	public String getSSID()
	{
		return ssid;
	}
	
	public String getLocation() {
		return location;
	}
	
	public int getHostChannel() {
		return host_channel;
	}
	
	public int getBeaconInterval() {
		return beacon_interval;
	}
	
	public long getLastBeaconTS() {
		return last_beacon_ts;
	}
	
	public int getRate() {
		return rate;
	}
	
	private void touch() {
		ts = System.currentTimeMillis();
	}
	
	public boolean isFresh() {
		return (System.currentTimeMillis() - ts) < FRESH_TIME;
	}

	public String getHostSSID() {
		return host_ssid;
	}
}
