/*
 * Created on Aug 22, 2003
 * 
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.instant802.cldc.channelplanner;

import java.util.Enumeration;
import java.util.Vector;

import com.instant802.cldc.radius.Utils;
import com.instant802.cldc.deviceconfiguration.ElementNotFoundException;
import com.instant802.cldc.deviceconfiguration.OrchestratorConfig;
import com.instant802.cldc.hostapd.HostAPD;
import com.instant802.cldc.hostapd.HostAPDRadio;
import com.instant802.cldc.orchestrator.AdminInterface;
import com.instant802.cldc.orchestrator.OrchestratorNode;

/**
 * @author robin
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class WirelessNeighborhoodModel
{

	private String name = null;
	private Vector records = new Vector();
	public static final String HOST_MAC = "host_mac";
	public static final String HOST_BAND = "host_band";
	public static final String HOST_CHANNEL = "host_channel";
	public static final String HOST_IP = "host_ip";
	public static final String HOST_LOAD = "host_load";
	public static final String HOST_NAME = "host_name";
	public static final String HOST_LOCATION = "host_location";
	public static final String HOST_SSID = "host_ssid";
	
	private OrchestratorNode node;

	public WirelessNeighborhoodModel(OrchestratorNode node, String name)
	{
		this.name = name;
		this.node = node;
	}

	public WirelessNeighborhoodModel(OrchestratorNode node)
	{
		this.node = node;
	}

	public Enumeration currentRecords()
	{
		HostAPD hostAPd = HostAPD.getHostAPD();
		String hostmac, hostband, hostname, hostip, hostchannel, hostload, hostssid;
		Enumeration radios;

		if (name != null)
		{
			Vector radiov = new Vector();
			radiov.addElement(hostAPd.getRadio(name));
			radios = radiov.elements();
		} else
		{
			radios = hostAPd.radios().elements();
		}
		hostip = new AdminInterface("br0").ipAddress();
		while (radios.hasMoreElements())
		{
			HostAPDRadio radio = (HostAPDRadio) radios.nextElement();
			hostname = radio.name();
			hostmac = new WirelessInterface(hostname).getHardwareAddress();
			hostband = hostAPd.getRadioBand(hostname);
			hostchannel = hostAPd.getRadioChannel(hostname);
			hostload = hostAPd.getRadioLoad(hostname);
			hostssid =  Utils.plainHex(hostAPd.getSSID(hostname).getBytes());

			for (Enumeration e = radio.Neighbors(); e.hasMoreElements();)
			{
				WirelessNeighborhoodRecord ap = (WirelessNeighborhoodRecord) e.nextElement();
				// Add the local host parameters so we can rebuild the map on an AP basis and not on a radio basis
				ap.field(HOST_MAC, hostmac);
				ap.field(HOST_BAND, hostband );
				ap.field(HOST_CHANNEL, hostchannel);
				ap.field(HOST_LOAD, hostload);
				ap.field(HOST_IP, hostip);
				ap.field(HOST_NAME, hostname);
				ap.field(HOST_SSID, hostssid);
				try
				{
					ap.field(HOST_LOCATION, node.configurationModel().getOrchestratorConfig().location());
				} catch (ElementNotFoundException e1)
				{
					ap.field(HOST_LOCATION, OrchestratorConfig.UNSET_LOCATION);
				}
				records.addElement(ap);
			}
		}
		return records.elements();
	}

}
