/*
 * Created on Sep 27, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.instant802.cldc.clustermembership;

import java.io.IOException;
import java.util.Enumeration;
import java.util.Vector;

import com.instant802.cldc.DataPath.XMLRecord;
import com.instant802.cldc.DataPath.XMLRepresentationException;
import com.instant802.cldc.LSQL.APConfException;
import com.instant802.cldc.LSQL.LSQLException;
import com.instant802.cldc.deviceconfiguration.ElementNotFoundException;
import com.instant802.cldc.deviceconfiguration.OrchestratorConfig;
import com.instant802.cldc.hostapd.HostAPD;
import com.instant802.cldc.hostapd.HostAPDRadio;
import com.instant802.cldc.messaging.Message;
import com.instant802.cldc.messaging.ReplyMechanism;
import com.instant802.cldc.net.MalformedHTTPMessageException;
import com.instant802.cldc.net.SocketException;
import com.instant802.cldc.orchestrator.OrchestratorNode;
import com.instant802.cldc.util.SimpleCommaDelimParser;

/**
 * @author robin
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class MembershipRequestMessage extends Message {

	public static final String TYPE = "MembershipRequestMessage";
	
	private Vector radiomacs = new Vector();
	/**
	 * @param record
	 * @throws XMLRepresentationException
	 */
	public MembershipRequestMessage( ReplyMechanism toReply, XMLRecord record)
		throws XMLRepresentationException {
		super(toReply, record );
	}

	/**
	 * @param node
	 */
	public MembershipRequestMessage(OrchestratorNode node) throws ElementNotFoundException {
		super( node );
		field( OrchestratorConfig.LOCATION, node.configurationModel().getOrchestratorConfig().location() );
		addRadios();
	}

	private void addRadios() {
		HostAPD hapd = HostAPD.getHostAPD();
		Vector radios =  hapd.radios();
		Enumeration en = radios.elements();
		String macs = "";
		while (en.hasMoreElements()) {
			String name = ((HostAPDRadio) en.nextElement()).name();
			String band = hapd.getRadioBand(name);
			String mac =  hapd.getRadioMac(name);
			if (macs.length() > 0)
				macs = macs + ",";
			macs = macs + mac.trim();
		}
		field(OrchestratorConfig.RADIO_MAC, macs);
	}
	
	/* (non-Javadoc)
	 * @see com.instant802.cldc.messaging.Message#onReceipt(com.instant802.cldc.orchestrator.OrchestratorNode)
	 */
	public void onReceipt(OrchestratorNode node) throws SocketException, XMLRepresentationException, IOException, MalformedHTTPMessageException, LSQLException, APConfException {
		node.membershipAgent().handleMembershipRequest( this );
	}
	
	/* (non-Javadoc)
	 * @see com.instant802.cldc.DataPath.XMLRepresentation#typeName()
	 */
	public String typeName() {
		return TYPE;
	}

	public String location() {
		return field( OrchestratorConfig.LOCATION );
	}
	
	public String radioMacs() {
		return field(OrchestratorConfig.RADIO_MAC);
	}
}
