/*
 * Created on Sep 29, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.instant802.cldc.deviceconfiguration;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.Enumeration;
import java.util.NoSuchElementException;

import org.kxml2.io.KXmlSerializer;
import org.kxml2.kdom.Element;
import org.kxml2.kdom.Node;
import org.xmlpull.v1.XmlSerializer;

import com.instant802.cldc.DataPath.XMLOutputBase;
import com.instant802.cldc.util.Log;

/**
 * @author robin
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public abstract class DOMBased extends XMLOutputBase {

	protected abstract Element getRoot();

	public void appendAsXML(StringBuffer document) {
		Element element = getRoot();
		XmlSerializer serializer = new KXmlSerializer();
		ByteArrayOutputStream os = new ByteArrayOutputStream( );
		try{
			serializer.setOutput( os, getEncoding() );
			element.write( serializer );
			serializer.flush();
			os.flush();
		} catch ( IOException e ) {
			Log.critical( "DOMBased", e );
		}
		document.append( new String( os.toByteArray() ) );
	}

	protected Element findObject( String type ) throws ElementNotFoundException {
		for( int i = 0; i < getRoot().getChildCount(); i++ ) {
			if( getRoot().getType( i ) == Node.ELEMENT ) {
				Element child = getRoot().getElement( i );
				if( child.getName().equals( type ) ) {
					return child;
				}
			}
		}
		throw new ElementNotFoundException("Couldn't find an object of type "+type+" in config " );
	}
	
	protected abstract class DOMEnumeration implements Enumeration {
		int i = 0;

		public boolean hasMoreElements() {
			Element root = getRoot();
			while( i < root.getChildCount() ) {
				if( found( i ) ) {
					return true;
				}
				i++;
			}
			return false;
		}

		abstract boolean found( int i );

		abstract Object result( int i );

		public Object nextElement() {
			while( i < getRoot().getChildCount() ) {
				if( found( i ) ) {
					return result( i++ );
				} else {
					i++;
				}
			}
			throw new NoSuchElementException( "no more elements" );
		}	
			}

	public Element createElement(String fieldname) {
		Element field;
		field = getRoot().createElement("", fieldname);
		getRoot().addChild(Element.ELEMENT, field);
		return field;
	}
}
