/*
 * Created on Nov 2, 2003
 * author: Robin Barooah
 * (C) 2003 Instant802 Networks Inc
 */
package com.instant802.cldc.deviceconfiguration;

import java.util.Enumeration;
import java.util.Vector;

/**
 * @author robin
 */
public class FieldChanges2 {
	
	private final Vector fields = new Vector();
	private final ConfigObject target;
	
	FieldChanges2( ConfigObject target ) {
		this.target = target;
	}

	void addField( String field ) {
		fields.addElement( field );
	}

	void removeField( String toRemove ) {
		Enumeration e = fields.elements();
		while( e.hasMoreElements() ) {
			String fieldName = (String) e.nextElement();
			if( fieldName.equals( toRemove ) )
			{
				fields.removeElement( toRemove );
				break;
			}
		}
	}
	
	public String typeName() {
		return target.typeName();
	}

	public ConfigObject object() {
		return target;
	}

	public Enumeration fieldNames() {
		return fields.elements();
	}
	
	public String field( String name ) {
		return target.field( name );
	}

	public int count() {
		return fields.size();
	}

	/**
	 * return true if the named field is part of the changed set
	 */
	
	public boolean hasField(String name) {
		return fields.contains( name );
	}
	
	/**
	 * return the list of fields indicated for change as a string
	 * primarily for debugging purposes.
	 */
	public String toString() {
		StringBuffer buffer = new StringBuffer();
		Enumeration e = fields.elements();
		buffer.append("( ");
		while( e.hasMoreElements() ) {
			String name = (String) e.nextElement();
			buffer.append( name );
			if( e.hasMoreElements() ) {
				buffer.append( ", " );
			}
		}
		buffer.append(" )");
		return buffer.toString();
	}
}
