/*
 * Created on Nov 2, 2003
 * author: Robin Barooah
 * (C) 2003 Instant802 Networks Inc
 */
package com.instant802.cldc.deviceconfiguration;

import java.util.Enumeration;

import com.instant802.cldc.DataPath.AppendableAsXML;

/**
 * @author robin
 */
public interface ObjectList extends AppendableAsXML {

	public String toString();

	/**
	 * return true of the list defines an object with the same identity (primary key)
	 * as the one supplied.
	 */
	public boolean defines( ConfigObject object );

	/**
	 * return the definition from this list of an object with the same identity (primary key)
	 * as the one supplied.
	 */
	public ConfigObject definition(ConfigObject candidate);
	
	/**
	 * return an enumeration of all object definitions in this list.
	 */
	public Enumeration elements();

	/**
	 * return the count of object definitions in this list.
	 */
	public int size();
	
	/**
	 * dump the identities and definitions of the objects in this list for debugging purposes.
	 */
	public void debugDump();
}
