/*
 * Created on Sep 5, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.instant802.cldc.discovery;

import com.instant802.cldc.DataPath.XMLRecord;
import com.instant802.cldc.DataPath.XMLRepresentationException;
import com.instant802.cldc.deviceconfiguration.ElementNotFoundException;
import com.instant802.cldc.deviceconfiguration.OrchestratorConfig;
import com.instant802.cldc.messaging.Message;
import com.instant802.cldc.messaging.ReplyMechanism;
import com.instant802.cldc.orchestrator.OrchestratorNode;
import com.instant802.cldc.util.DateUtil;

/**
 * @author robin
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class AnnouncementMessage extends Message {

	public static final String TYPE = "AnnouncementMessage";
	private final transient long timestamp;
	
	/**
	 * @param record
	 */
	public AnnouncementMessage( ReplyMechanism toReply, XMLRecord record) throws XMLRepresentationException {
		super( toReply, record );
		timestamp = DateUtil.now();
	}

	AnnouncementMessage(OrchestratorNode node ) throws ElementNotFoundException {
		super( node );
		timestamp = DateUtil.now();
		field( OrchestratorConfig.LOCATION, node.configurationModel().getOrchestratorConfig().location() );
	}

	public void onReceipt(final OrchestratorNode node  ) {
		/* the disccovery engine keeps track of recent announcements, so when one is received,
		 * it should be added to the discovery engine.
		 */
		node.discoveryEngine().addAnnouncement( this );
	}

	public String typeName() {
		return TYPE;
	}
	
	public long getTimestamp() {
		return timestamp;
	}
}
