/*
 * Created on Sep 16, 2003
 * 
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.instant802.cldc.net;

import java.io.IOException;
import java.io.InputStream;
import java.io.PrintStream;
import com.instant802.cldc.util.Log;
import com.instant802.cldc.net.Socket;

/**
 * @author robin
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class HTTPClient
{
	private static final int BLOCK_SIZE = 8192;

	public HTTPResponse doRequest(HTTPRequest request)
		throws IOException, MalformedHTTPMessageException, SocketException
	{
		final Socket connection = new Socket();
		try
		{
			connection.connect(
				request.getHost(),
				Integer.parseInt(request.getPort()));
			sendRequest(request, connection);
			return new HTTPResponse(readResponse(connection));
		}
		catch (SocketException se) {
			throw new IOException(se.getMessage());
		}
		finally
		{
			connection.close();
		}
	}

	private StringBuffer readResponse(Socket connection) throws IOException
	{
		try
		{
			byte[] buffer = new byte[BLOCK_SIZE];
			StringBuffer received = new StringBuffer();
			int count;
			do
			{
				count = connection.read(buffer, BLOCK_SIZE);
				if (count > 0)
				{
					String content = new String(buffer, 0, count);
					received.append(content);
				}
			}
			while (count > 0);
			return received;
		}
		catch (SocketException e)
		{
			connection.close();			
			throw new IOException(e.getMessage());
		}
	}

	private void sendRequest(HTTPRequest request, Socket connection)
		throws IOException, MalformedHTTPMessageException
	{
		try
		{
			// byte[] buf = request.getMessage().toString().getBytes();
			// Alan - non-standard opt
			byte[] buf = request.getMessage().getBytes();
			connection.write(buf, buf.length);
		}
		catch (SocketException se)
		{
			connection.close();			
			throw new IOException(se.getMessage());
		}
	}
}
