/*
 * Created on Sep 16, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package com.instant802.cldc.net;

import com.instant802.cldc.ssl.SSL;
import com.instant802.cldc.ssl.SSLSessionContext;

/**
 * @author alan
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class SSLServerSocket extends ServerSocket
{
	SSL ssl;
	SSLSessionContext ctx;
	/**
	 * isClient and isHandshook are used to delay the ssl-level accept or connect.
	 * 
	 */
	boolean isClient, isHandshook; 
	
	
	public SSLServerSocket(SSLSessionContext ctx) throws SocketException
	{
		super();
		try{
			ssl = new SSL(ctx);
			this.ctx = ctx;
		} catch ( NullPointerException e ) {
			exitOnNullPointer( e );
		}
		
	}
	
	/**
	 * We delay the actuall ssl.accept until we attempt to read or write
	 * through the SSLSocket -- this allows 'SSL connections' to return without 
	 * 'SSL accepts' if the socket is setup to use a backlog - which more
	 * closely mimics vanilla sockets
	 */
	public Socket accept() throws SocketTimeoutException, SocketException
	{
		try{
			Socket sock;
			
			sock = super.accept();
			if (SSL.encrypt)
			{
				sock = (Socket) new SSLSocket(ctx, sock.sd);
			}
			return sock;
		} catch ( NullPointerException e ) {
			exitOnNullPointer( e );
			return null;
		}	
	}	
}
