/*
 * Created on Sep 16, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package com.instant802.cldc.net;

import com.instant802.cldc.ssl.SSL;
import com.instant802.cldc.ssl.SSLSessionContext;
import com.instant802.cldc.util.Log;

/**
 * @author alan
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class SSLSocket extends Socket
{
	SSL ssl;
	SSLSessionContext ctx;
	
	boolean shouldAccept, accepted, shouldConnect, connected;
	
	/**
	 * This is always generated from  server socket and hence
	 * is awaiting an accpet
	 */
	public SSLSocket(SSLSessionContext ctx, int sd) throws SocketException
	{
		super(sd);
		try{
			ssl = new SSL(ctx);
			ssl.setFd(sd);
			this.ctx = ctx;
			shouldAccept = true;
			accepted = false;
			shouldConnect = false;
			connected = false;
			if (Log.DEBUG) debug("ssl socket created, sd="+sd);
		} catch ( NullPointerException e ) {
			exitOnNullPointer( e );
		}
	}
	
	public SSLSocket(SSLSessionContext ctx) throws SocketException
	{
		super();
		try{
			ssl = new SSL(ctx);
			ssl.setFd(sd);
			this.ctx = ctx;
			shouldAccept = false;
			accepted = false;
			shouldConnect = true;
			connected = false;
			if (Log.DEBUG) debug("ssl socket created from sd "+sd);
		} catch ( NullPointerException e ) {
			exitOnNullPointer( e );
		}		
	}
	
	public SSL getSSL()
	{
		return ssl;
	}
	
	private synchronized void finalizeConnection() throws SocketException
	{
		if (shouldAccept && !accepted)
		{
			if (Log.DEBUG) debug("finalizing connection");
			ssl.accept();
			accepted = true;
		} else if (shouldConnect && ! connected) {
			ssl.connect();
			connected = true;
		}		
	}
	
	public int read(byte[] buffer, int buffersize) throws SocketException
	{
		checkSizes(buffer, buffersize, "read" );				
		if (SSL.encrypt)
		{
			checkOpen();
			finalizeConnection();
			
			int read = ssl.read(this, buffer, buffersize);
			
			if (read < 0)
			{
				ctx.printErrors();
				throw new SocketException("SSL read error:" + read);
			}
			return read;
		}
		else
		{
			return super.read(buffer, buffersize);
		}
	}
	
	public int write(byte[] buffer, int buffersize) throws SocketException
	{
		checkSizes(buffer, buffersize, "write" );		
		if (SSL.encrypt)
		{
			checkOpen();
			
			finalizeConnection();
			
			int written = ssl.write(this, buffer, buffersize);
			
			if (written != buffersize)
				throw new SocketException("SSL write error:" + written);
			return written;
		}
		else
		{
			return super.write(buffer, buffersize);
		}
	}
	
	public void setTimeout( int timeout ) {
		ssl.setTimeout( timeout );
	}
	
	private void debug(String string) {
		if (Log.DEBUG) Log.debug("SSLSocket", string );
	}
	
	public void close() {
		ssl.close();
		super.close();
	}
}
