/*
* Created on Aug 26, 2003
*
* To change the template for this generated file go to
* Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
*/
package com.instant802.cldc.net;

import com.instant802.cldc.linux.NetInterface;
import com.instant802.cldc.util.Log;

/**
* @author robin
*
* To change the template for this generated type comment go to
* Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
*/
class SocketBase extends UnixNativeSocket {
	
	protected int timeout = 20000; // default socket timeout is 20 seconds.
	protected int sd = 999;
	
	/**
* @param TIMEOUT
*/
	public void setTimeout(int timeout) {
		this.timeout = timeout;
	}
	
	
	protected synchronized final void construct() throws SocketException {
		try{
			sd = createSocketState();
			if( sd == -1 ) {
				throw new SocketException("failed to create socket (-1 returned from native call)");
			}
			if (Log.DEBUG) debug("creating socket "+sd );
		} catch ( NullPointerException e ) {
			exitOnNullPointer( e );
		}
	}
	
	protected synchronized final void constructDatagram() throws SocketException {
		try{
			sd = createDatagramSocketState();
			if( sd == -1 ) {
				throw new SocketException("failed to create datagram socket (-1 returned from native call)");
			}
		} catch ( NullPointerException e ) {
			exitOnNullPointer( e );
		}
	}
	
	protected synchronized final void constructUnixDomainDatagram() throws SocketException {
		try{
			sd = createUnixDomainDatagramSocketState();
			if( sd == -1 ) {
				throw new SocketException("failed to create unix domain datagram socket (-1 returned from native call)");
			}
		} catch ( NullPointerException e ) {
			exitOnNullPointer( e );
		}
	}
	
	
	protected synchronized int getSocketDescriptor() {
		return sd;
	}
	
	public void bindToInterface( NetInterface iface ) {
		try{
			nativeBindToDevice( sd, iface.getDeviceName() );
 		} catch ( NullPointerException e ) {
			exitOnNullPointer( e );
		}
	}
	
	final synchronized void construct( int sd ) {
		this.sd = sd;
	}
	
	public void finalize() {
		//              close();
	}
	
	//public boolean success() {
	//return getReturnCode( state ) == 0;
	//}
	
	// public int getErrno() {
	// return getErrno(state);
	// }
	
	public synchronized void close() {
		if( sd >= 0 ) {
			destroy(sd);
			sd = -1;
		} else {
			if (Log.DEBUG) debug("socket already destroyed");
		}
	}
	
	protected String ip2str(int ip) {
		StringBuffer str = new StringBuffer("");
		int octet;
		
		for (int i = 3; i >= 0; --i) {
			octet = 0xFF & (ip >> (i * 8));
			if (i < 3)
				str.append(".");
			str.append(octet);
		}
		return str.toString();
	}
	
	private void debug(String string) {
		if (Log.DEBUG) Log.debug("SocketBase", string );
	}
	
	/**
* 
*/
	public synchronized void checkOpen() throws SocketException {
		if( sd == -1 )
			throw new SocketException("socket closed");
	}
	
	
	protected void checkSizes(byte[] buffer, int buffersize, String operation) throws SocketException {
		if( buffer.length < buffersize ) {
			throw new SocketException( "number of bytes ("+buffer.length+") to "+operation+" is greater than supplied buffer ("+buffersize );
		}
		if( buffer.length < 1 ) {
			throw new SocketException( "buffer length ("+buffer.length+") cannot be less than 1");
		}
		if( buffersize < 1 ) {
			throw new SocketException( "bytes to "+operation+" ("+buffersize+") cannot be less than 1");
		}
	}        
	
	protected void exitOnNullPointer( NullPointerException e ) {
		try{
			Log.emergency( "SocketBase", e );
		} finally {
			System.exit( 1 );
		}
	}
}
