/*
 * Created on Jan 23, 2004
 * 
 * To change the template for this generated file go to Window - Preferences -
 * Java - Code Generation - Code and Comments
 */
package com.instant802.cldc.qdxml;

import java.util.Vector;
import org.kxml2.kdom.*;

import com.instant802.cldc.util.Log;

import java.util.Stack;

/**
 * @author alan
 * 
 * To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Generation - Code and Comments
 */
public class DomHandler implements DocHandler
{
	Document root;
	Stack stack;

	private static final int START_DOC = 1, OPEN_TAG = 2, DONE = 3;

	private int mode;
	private Element curelm;

	public DomHandler()
	{
		stack = new Stack();
	}

	public void startElement(String tag, Vector attrs) throws Exception
	{
		if (mode == START_DOC)
		{
			Element elm = root.createElement("", tag );
			curelm = elm;
			root.addChild(Node.ELEMENT, curelm);
		} else if (mode == OPEN_TAG)
		{
			Element elm = curelm.createElement("", tag );
			curelm.addChild(Node.ELEMENT, elm);
			stack.push(new State(mode, curelm));
			curelm = elm;
		} else
			throw new Exception(
				"DomHandler - bad mode: startElement - " + mode);

		int len = attrs.size();
		for (int i = len - 1; i >= 0; --i)
		{
			Object[] list = (Object[]) attrs.elementAt(i);
			curelm.setAttribute("", (String) list[0], (String) list[1]);
		}
		mode = OPEN_TAG;
	}

	public void endElement(String tag) throws Exception
	{
		if (stack.size() > 0)
		{
			State s = (State) stack.pop();
			mode = s.mode;
			curelm = s.elm;
		} else
		{ // We are done
			mode = DONE;
		}
	}

	public void startDocument() throws Exception
	{
		root = new Document();
		mode = START_DOC;
	}

	public void endDocument() throws Exception
	{
		if (mode != DONE)
			throw new Exception("DomHandler - bad mode: end");
	}

	public void text(String str) throws Exception
	{
		curelm.addChild(Node.TEXT, str);
	}

	public Document getRoot()
	{
		return root;
	}
}

class State
{
	public int mode;
	public Element elm;

	public State(int mode, Element elm)
	{
		this.mode = mode;
		this.elm = elm;
	}
}