/*
 * Created on Jul 29, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package com.instant802.cldc.radius;

import com.instant802.cldc.ssl.SSLParameterException;

/**
 * @author alan
 *
 * An object to encapsulate response infomration from the challenge verification process
 * which will then have to be passed on to the MSChapV2
 */
public class MSChapV2VerifyChallengeResponse
{
	byte[] hashedpassword;
	byte[] ntResponse;
	byte[] peerChallenge;
	byte[] authenticatorChallenge;
	byte[] userName;
	byte chapid;
	boolean success;

	/**
	 * @param bs
	 */
	public void setAuthenticatorChallenge(byte[] bs)
	{
		authenticatorChallenge = bs;
	}

	/**
	 * @param bs
	 */
	public void setNtResponse(byte[] bs)
	{
		ntResponse = bs;
	}

	/**
	 * @param bs
	 */
	public void setHashedPassword(byte[] bs)
	{
		hashedpassword = bs;
	}

	/**
	 * @param bs
	 */
	public void setPeerChallenge(byte[] bs)
	{
		peerChallenge = bs;
	}

	/**
	 * @param bs
	 */
	public void setUserName(byte[] bs)
	{
		userName = bs;
	}

	/**
	 * @param b
	 */
	public void setSuccess(boolean b)
	{
		success = b;
	}

	/**
	 * 
	 * @return Data for an MSChapV2 style CHap packet containing success or failure
	 */
	public CHAPPacket generateResponsePacket() throws SSLParameterException
	{
		CHAPPacket chap;

		if (success)
		{
			byte[] packet =
				new MSCHAPV2Method(null, null, null).generateAuthenticatorResponse(
					hashedpassword,
					ntResponse,
					peerChallenge,
					authenticatorChallenge,
					userName);
			
			chap = new CHAPPacket(CHAPPacket.CHAP_SUCCESS, chapid, packet, (byte) packet.length);
		}
		else
		{
			StringBuffer msg = new StringBuffer("E=691 R=1 C=");  // Error is always auth. failed
			msg.append(Utils.hexstr(authenticatorChallenge, authenticatorChallenge.length));
			msg.append(" V=3");
			byte[] packet = msg.toString().getBytes();
			chap =  new CHAPPacket(CHAPPacket.CHAP_FAILURE, chapid, packet, (byte)packet.length);
		}
		return chap;
	}

	/**
	 * @param b
	 */
	public void setChapid(byte b)
	{
		chapid = b;
	}

}
