/*
 * Created on Apr 24, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package com.instant802.cldc.radius;

/**
 * @author alan
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class PEAPPacket
{
	public final static byte LBIT = (byte) 0x80, MBIT = 0x40, SBIT = 0x20;
	public final static byte VERSION = 0x00; // Microsoft's F!d Version XP SP1 version for now

	private byte[] data;

	public static byte[] startPacket()
	{
		byte[] packet = new byte[1];

		packet[0] = SBIT | VERSION;
		return packet;
	}

	public PEAPPacket(byte[] data)
	{
		this.data = data;
	}

	public byte getFlags()
	{
		return data[0];
	}

	public byte getVersion()
	{
		return (byte) (getFlags() & 0x02);
	}

	public int getMsgLength() // Only valid if LBIT is set
	{
		int length;

		length = (0x00ff & data[1]);
		length = (length << 8) + (0x00ff & data[2]);
		length = (length << 8) + (0x00ff & data[3]);
		length = (length << 8) + (0x00ff & data[4]);
		return length;
	}

	/**
	 * @return TLS layer data
	 */
	public byte[] getTLSData()
	{
		byte[] tlsdata;

		if (0 == (getFlags() & LBIT))
		{
			tlsdata = new byte[data.length - 1];
			System.arraycopy(data, 1, tlsdata, 0, tlsdata.length);

		}
		else
		{
			tlsdata = new byte[data.length - 5]; // flags and msg length
			System.arraycopy(data, 5, tlsdata, 0, tlsdata.length);
		}
		return tlsdata;
	}
}
