/*
 * Created on Dec 18, 2003
 * author: Robin Barooah
 * (C) 2003 Instant802 Networks Inc
 */
package com.instant802.cldc.synchronization;

import com.instant802.cldc.Activation.Activator;
import com.instant802.cldc.Activation.InvocationMessage;
import com.instant802.cldc.Activation.InvocationResult;
import com.instant802.cldc.Activation.Service;
import com.instant802.cldc.Activation.ServiceInstanceManager;
import com.instant802.cldc.orchestrator.OrchestratorNode;

/**
 * @author robin
 */
public class SynchronizationService extends Service {

	private static final String TYPE = "SynchronizationService";
	private final OrchestratorNode node;
	private static SynchronizationService instance;
	
	public SynchronizationService(OrchestratorNode node) {
		this.node = node;
	}

	public synchronized static SynchronizationService getInstance( OrchestratorNode node ) {
		if( instance == null ) {
			instance = new SynchronizationService( node );
		}
		return instance;
	}
	
	protected boolean doMethod(
		String method,
		InvocationMessage message,
		InvocationResult result)
		throws Exception {
		if (method.equals("synchronizeCluster")) {
			node.synchronizationAgent().synchronizeCluster();
			return true;
		}
		return false;
	}

	static class InstanceManager extends ServiceInstanceManager {
		public String typeName() {
			return TYPE;
		}

		/* (non-Javadoc)
		 * @see com.instant802.cldc.Activation.ServiceInstanceManager#getInstance(com.instant802.cldc.cluster.OrchestratorNode, com.instant802.cldc.Activation.Activator)
		 */
		public Service getInstance(
				String name,
				OrchestratorNode node,
				Activator a)
		throws Exception {
			return SynchronizationService.getInstance( node );
		}
	}
}
