/*
 * Created on Oct 1, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.instant802.cldc.synchronization;

import java.io.IOException;

import com.instant802.cldc.DataPath.XMLRecord;
import com.instant802.cldc.DataPath.XMLRepresentationException;
import com.instant802.cldc.LSQL.APConfException;
import com.instant802.cldc.LSQL.LSQLException;
import com.instant802.cldc.clustermastering.AgentNotRunningException;
import com.instant802.cldc.clustermastering.InvalidTimingException;
import com.instant802.cldc.deviceconfiguration.ElementNotFoundException;
import com.instant802.cldc.deviceconfiguration.ObjectList;
import com.instant802.cldc.messaging.Message;
import com.instant802.cldc.messaging.ReplyMechanism;
import com.instant802.cldc.net.MalformedHTTPMessageException;
import com.instant802.cldc.net.SocketException;
import com.instant802.cldc.orchestrator.OrchestratorNode;

/**
 * @author robin
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class SynchronizationSetMessage extends Message {

	public static final String CURRENT_OBJECTS = "current_objects";
	public static final String TYPE = "SynchronizationSetMessage";
	/**
	 * @param toReply
	 * @param record
	 * @throws XMLRepresentationException
	 */
	public SynchronizationSetMessage(ReplyMechanism toReply, XMLRecord record)
		throws XMLRepresentationException {
		super(toReply, record);
	}

	public SynchronizationSetMessage(OrchestratorNode node, ObjectList objects)
		throws ElementNotFoundException {
		super(node);
		field(CURRENT_OBJECTS, objects);
	}

	public void onReceipt(OrchestratorNode node)
		throws
			ElementNotFoundException,
			XMLRepresentationException,
			IOException,
			MalformedHTTPMessageException,
			LSQLException,
			APConfException,
			InvalidTimingException,
			SocketException,
			AgentNotRunningException {
				node.nodeStatusRecord().setClusterStatus("processing configuration update from cluster");
				node.synchronizationAgent().synchronize(this);
	}

	public String typeName() {
		return TYPE;
	}

	public ObjectList currentObjects() {
		return objectsField(CURRENT_OBJECTS);
	}
}
