/*
 * Created on Aug 27, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.instant802.cldc.util;

/**
 * @author robin
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class Log {

	private static boolean TRACE_EXCEPTIONS = true;
	private static boolean local = true;
//	private static int FILTER_LEVEL = SyslogMessage.INFORMATIONAL;
	private static int FILTER_LEVEL = SyslogMessage.DEBUG;
	
	// Set the following true to get debug messages out of the logger
	public static final boolean DEBUG = false;

	public static void setRemote() {
		local = false;
	}

	public static void setFilterLevel( int level ) {
		FILTER_LEVEL = level;
	}

	private static void log(int pri, String message) {
		if (pri <= FILTER_LEVEL) {
			SyslogMessage m =
				new SyslogMessage(
					"("
						+ (Runtime.getRuntime().freeMemory() / 1024)
						+ " KB) "
						+ threadIndicator()
						+ message);
			m.setPriority(pri);
			if (!local) {
				SyslogSender.send(m);
			} else {
				System.out.println(m);
			}
		}
	}

	private static String threadIndicator() {
		String threadID = ThreadCounter.getId(Thread.currentThread());
		return (null != threadID) ? "[" + threadID + "] " : "";
	}

	public static void debug(String s) {
		log(SyslogMessage.DEBUG, s);
	}

	public static void info(String s) {
		log(SyslogMessage.INFORMATIONAL, s);
	}

	public static void error(Exception e) {
		trace( e );
		log(SyslogMessage.ERROR, e.getMessage());
	}

	public static void error(String s) {
		log(SyslogMessage.ERROR, s);
	}

	public static void emergency(String s) {
		log(SyslogMessage.EMERGENCY, s);
	}

	public static void notice(String s) {
		log(SyslogMessage.NOTICE, s);
	}

	public static void debug(String object, String message) {
		log(SyslogMessage.DEBUG, object, message);
	}

	private static void log(int i, String object, String message) {
		log(i, object + "->" + message);
	}

	public static void error(String string, Exception e) {
		trace( e );
		log(SyslogMessage.ERROR, string, e.getMessage());
	}

	public static void warning(Exception e) {
		trace( e );
		log(SyslogMessage.WARNING, e.getMessage());
	}

	public static void warning(String string) {
		log(SyslogMessage.WARNING, string);
	}

	public static void warning(String string, String message) {
		log(SyslogMessage.WARNING, string, message);
	}

	public static void warning(String string, Exception e) {
		trace( e );
		warning(string, e.getMessage());
	}

	public static void critical(Throwable e) {
		trace( e );
		log(
			SyslogMessage.CRITICAL,
			"CRITICAL: " + e.getMessage().toUpperCase());
	}

	public static void critical(String string) {
		log(SyslogMessage.CRITICAL, "CRITICAL: " + string.toUpperCase());
	}

	public static void emergency(Throwable e) {
		trace( e );
		emergency(e.toString());
	}

	public static void critical(String string, Throwable e) {
		trace( e );
		log(
			SyslogMessage.CRITICAL,
			string,
			"CRITICAL: " + e.getMessage().toUpperCase());
	}

	/**
	 * @param string
	 * @param e
	 */
	public static void emergency(String string, Exception e) {
		trace( e );
		log(
			SyslogMessage.EMERGENCY,
			string,
			"EMERGENCY: " + e.getMessage().toUpperCase());
	}

	private static void trace(Throwable e) {
		if( TRACE_EXCEPTIONS ) {
			e.printStackTrace();
		} 		
	}

	public static void info(String object, String message) {
		log( SyslogMessage.INFORMATIONAL, object, message );
	}
}
