/*
 * Created on Sep 4, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.instant802.cldc.util;

import java.io.IOException;

import com.instant802.cldc.net.Datagram;
import com.instant802.cldc.net.UDPDatagramSocket;
import com.instant802.cldc.net.SocketException;

/**
 * @author robin
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class SyslogSender {

	static final int PORT = 514;

	UDPDatagramSocket connection;

	private static SyslogSender sender;
	private static String server = "10.10.100.122"; // default server TODO: change the default syslog server

	public SyslogSender( ) throws IOException {
		try
		{
			connection =new UDPDatagramSocket();
		}
		catch (SocketException e)
		{
			throw  new IOException(e.getMessage());	
		}
	}
	
	public static void setServer( String s ) {
		server = s;
	}
	
	private static synchronized SyslogSender sender() throws IOException {
		if( sender == null ) {
			if( server != null ) {
				sender = new SyslogSender( );
			} else {
				throw new IOException( "syslog server not set");
			}
		}
		return sender;
	}

	public static void send( String message ) {
		send( new SyslogMessage( message ));
	}
 	
	public static void send( SyslogMessage message ) {
		try {
			sender().doSend( message );
		} catch (Exception e) {			
			System.out.println( message );
		}
	}
	
	private void doSend( SyslogMessage message ) throws SocketException {
		byte[] toSend = message.toString().getBytes();
		Datagram data = new Datagram(toSend, (short)toSend.length );
		data.setAddress(server);
		data.setPort(PORT);
		connection.send( data );
	}
	
	public void close() throws IOException {
		if( connection != null ) {
			connection.close(); 
			connection = null;
		}
	}
}
