
CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
	  else if [ -x /bin/bash ]; then echo /bin/bash; \
	  else echo sh; fi ; fi)

OAP_TOPDIR	:= $(shell pwd)


OAP_UID		=  $(shell echo $(CONFIG_OAP_UID))

export OAP_TOPDIR \
	OAP_UID

# Any target that has the word 'tools' somewhere in it doesn't 
# get these variables set. This allows us to use the host tools 
# rather than the target tools.
ifeq ($(shell echo "$(MAKECMDGOALS)" | grep "tool"),)

#
# Endian selection flags - needed only when the default output of
# the compiler does not match the required endian setting
#

DESTDIR		=  $(OAP_TOPDIR)/rootfs
BUILDTIME_FILE  =  $(DESTDIR)/etc/buildtime
SCRIPTS_DIR	=  $(OAP_TOPDIR)/scripts

TARGET_CONFIG	=  $(OAP_TOPDIR)/config/$(OAP_TARGET)/config.in

LINUX_SOURCE    ?=  $(OAP_TOPDIR)/apps/linux
CROSS_COMPILE	=  $(shell echo $(CONFIG_OAP_CROSS_COMPILE))
CC		=  $(CCACHE) $(CROSS_COMPILE)gcc
CXX		=  $(CCACHE) $(CROSS_COMPILE)g++
LD		=  $(CROSS_COMPILE)gcc
AR		=  $(CROSS_COMPILE)ar
JAVA 		= /opt/j2sdk1.4.2/bin/java
JAVAC 		= /opt/j2sdk1.4.2/bin/javac 
JAR 		= /opt/j2sdk1.4.2/bin/jar

ifeq ($(CONFIG_OAP_DEBUG),y)
STRIP		=  true
else
STRIP		=  $(CROSS_COMPILE)strip --remove-section=.note --remove-section=.comment
endif
OBJCOPY		=  $(CROSS_COMPILE)objcopy
RANLIB		=  $(CROSS_COMPILE)ranlib
CFLAGS		=  $(EXTRA_CPU_FLAGS) -Wall -Wstrict-prototypes $(EXTRA_CFLAGS)
ifneq ($(CONFIG_OAP_DISABLE_OPTIMIZATION),y)
CFLAGS		+=  -O2 
endif
LDFLAGS		=  $(EXTRA_LDFLAGS)
INSTALL		=  /usr/bin/install
HOSTCC		=  gcc
PATH		:= $(PATH):/sbin:/usr/sbin
PRODUCT		?= SMB
STYLE		?= CORPORATE

export	OAP_TARGET \
	DESTDIR \
	LINUX_SOURCE \
	CROSS_COMPILE \
	CC \
	CXX \
	LD \
	AR \
	STRIP \
	OBJCOPY \
	RANLIB \
	CFLAGS \
	LDFLAGS \
	INSTALL \
	PATH \
	HOSTCC \
	PRODUCT \
	STYLE

endif
