/**
* QLIB 1.0 Progress Control
* Copyright (C) 2002 2003, Quazzle.com Serge Dolgov
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
* http://qlib.quazzle.com
*/
function QProgress_update() {
with (this) {
if( !rendered ) {
alert("Progress component must be rendered before it can be updated");
}
var i = low;
for (var j=0; j<size; j++) {
images[j].src = i < value ? imgsrc1 : imgsrc0;
i += delta;
}
}
}
function QProgress_set(value) {
this.value = value - 0;
this.update();
}
function QProgress_setBounds(low, high) {
this.low = Math.min(low, high);
this.high = Math.max(low, high);
this.delta = (this.high - this.low) / this.size;
this.update();
}
function QProgress_render() {
with (this) {
var hor = this.style < 2;
var rev = this.style % 2;
document.write('<table class="qprogress" style="" border="0"  cellspacing="0" cellpadding="0" unselectable="on" ' +
(hor ? 'width="' + (size * res.width) + '" height="' + res.height + '"><tr>' : 'width="' + res.width +
'" height="' + (size * res.height) + '">'));
for (var j=0; j<size; j++) {
document.write((hor ? '' : '<tr>') + '<td width="' + res.width + '" height="' + res.height +
'" unselectable="on"><img name="' + id + (rev ? size - j - 1 : j) + '" src="' + res.list[0].src +
'" border="0" width="' + res.width + '" height="' + res.height + '"></td>' + (hor ? '' : '</tr>'));
}
document.write((hor ? '</tr>' : '') + '</table>');
for (var j=0; j<size; j++) {
images[j] = document.images[id + j] || new Image(1, 1);
}
rendered = true;
}
}
function QProgress(parent, name, res, size, style) {
this.init(parent, name);
if (!res) {
res = SEGS;
}
this.res = res;
this.value = 0;
this.low = 0;
this.high = 100;
this.size = size || 10;
this.delta = 100 / this.size;
this.style = style || 0;
this.images = new Array(this.size);
this.imgsrc0 = res.list[0] && res.list[0].src;
this.imgsrc1 = res.list[1] && res.list[1].src;
this.set = QProgress_set;
this.update = QProgress_update;
this.setBounds = QProgress_setBounds;
this.render = QProgress_render;
this.rendered = false;
}
QProgress.prototype = new QControl();
QProgress.NORMAL    = 0;
QProgress.REVERSE   = 1;
QProgress.FALL      = 2;
QProgress.RISE      = 3;
<!-- Defines class for handing a submit button that waits for local modifications to        -->
<!-- be distributed before commiting to server.  The locally_modified flag is polled for    -->
<!-- until it is equal to 0, otherwise if maxSconds is reached, displays a timeout message.  -->
<!-- see polling.js																			-->
SEGS = new QImageList(8, 17, "pro0.gif", "pro1.gif");
function UpdateProgress() {
this.base = QProgress;
this.base(null, "i802UpProg", SEGS);
this.maxSeconds = 40;
this.high = this.maxSeconds;
this.delta = (this.high - this.low) / this.size;
this.onSubmitHandler; // original form submit handler.
this.form; // form to be submitted
this.handleSubmit = _handleSubmit;
this.handleSubmitUpdate = _handleSubmitUpdate;
this.handleResponse = _handleResponse;
this.incrementProgress = _incrementProgress;
this.handleSyncComplete = _handleSyncComplete;
this.submitForm = _submitForm;
this.progressCount; // how long to wait for update to complete before timing out.
this.updateOnTimeout = false;
this.responseWaitCount = 0; // wait for poll response time.
this.maxResponseWait = 2; // max wait for any response.
this.disabled; // original disabled state of form elements
this.enableAll = _enableAll; // enable all form fields and tabs.
this.disableAll = _disableAll; // disable all form fields and tabs.
}
UpdateProgress.prototype = new QProgress();
var currentUpdate;
function _handleSubmit(name, value) {
this.handleSubmitUpdate(name, value, false);
}
function _handleSubmitUpdate(name, value, updateOnTimeoutIn) {
if( currentUpdate ) {
return false;
}
currentUpdate = this;
this.updateOnTimeout = updateOnTimeoutIn;
this.responseWaitCount = 0;
this.progressCount = 0;
if(this.disabled) this.disabled.length = 0; else this.disabled = new Array();
var submitParam = document.getElementById("submitParam");
if( ! submitParam ) {
alert("Unable to find form parameter submitParam");
return true;
}
submitParam.name = name;
submitParam.value = value;
this.form = submitParam.form;
if( this.form ) {
this.onSubmitHandler = this.form.onsubmit;
// call handler and return if handler returns false.
if( this.onSubmitHandler ) {
var submitResult = this.onSubmitHandler();
if( !submitResult ) {
return false;
}
}
this.form.onsubmit = function() { return false; };
}
else {
alert("Unable to find main form");
return true;
}
currentUpdate.value = 0;
startPolling( 1000, 'locally_modified' ); // poll every second
this.responseTimerId = window.setTimeout('triggerHandleResponse()', 0);
return false;
}
function triggerHandleResponse() {
currentUpdate.handleResponse();
}
function _handleResponse() {
if( !document.cluster ) { // if not defined, server has yet to respond
if( this.responseWaitCount < this.maxResponseWait ) { // give it time to get a value						
this.responseWaitCount++;
window.setTimeout('triggerHandleResponse()', 250);
return;
}
}
if(this.responseTimerId) window.clearTimeout(this.responseTimerId);
this.disableAll(); // disable all form elements
// if value of locally_modified is already 0 then do not show a progress bar.
if( document.cluster && document.cluster.locally_modified == "0" ) {
stopPolling();
this.submitForm();
return;
}
// if the server has yet to respond or locally_modified == 1, start progress bar.
this.incrementProgressTimerId = window.setTimeout('triggerIncrementProgress()', 0);
}
function triggerIncrementProgress() {
currentUpdate.incrementProgress();
}
function _incrementProgress() {
var div = document.getElementById("updateProgressId");
if( div ) {
div.style.visibility = "visible"; // show progress bar.
}
if( document.cluster && document.cluster.locally_modified == "0" ) {
if(this.incrementProgressTimerId) window.clearTimeout(this.incrementProgressTimerId);
this.handleSyncComplete(true);
return;
}
if(this.progressCount >= this.maxSeconds) { // timeout after max seconds.
if(this.incrementProgressTimerId) window.clearTimeout(this.incrementProgressTimerId);
this.handleSyncComplete(false);
return;
}
if(this.value >= this.maxSeconds) { // in case we want to wrap
this.set(0);
}
else {
this.set(this.value + 1);
}
this.progressCount++;
window.setTimeout('triggerIncrementProgress()', 1000);
}
function _handleSyncComplete( send ) {
var div = document.getElementById("updateProgressId");
div.style.visibility = "hidden"; // hide progress bar.
stopPolling();
if( send || this.updateOnTimeout) {
this.submitForm();
}
else {
alert( "Update failed." );
this.enableAll(); // reenable all form elements
this.form.onsubmit = this.onSubmitHandler;
}
currentUpdate = null;
}
function _submitForm() {
this.enableAll(); // reenable all form elements
this.form.submit();
this.form.onsubmit = this.onSubmitHandler;
}			  
function _disableAll()
{
if( this.form ) {
for(var i = 0; i < this.form.elements.length; i++)
{
this.disabled[i] = this.form.elements[i].disabled;
this.form.elements[i].disabled = true;
}
}
disableTabs();
}
function _enableAll()
{
if( this.form ) {
for(var i = 0; i < this.form.elements.length; i++)
{
if( ! this.disabled[i] ) { // if previously disabled do not enable.
this.form.elements[i].disabled = false;
}
}
}
enableTabs();
}
